{$F+}

PROGRAM Inspektor;

(* Spezialversion zur Abfrage des CD-ROM-Dudenwrterbuches in der Maus *)

(* (C) 1994 by Johannes Leckebusch. Das Programm ist Shareware im Rahmen
   des Superfilter-Paketes.

   Stand: Oktober 1994
*)

USES Crt, Superbase;

CONST
        cVersion =      0.500;
        DefaultDrucker = 'LPT1';
        DruckEinrueck = '        ';
        DruckZeilen =   59;

CONST
  KopfPos =      1;
  StartDisplay = 2;
  EndDisplay =   24;
  FussPos =      25;
  SpaltenOff =   12;
  StartSpalte =  1;
  EndSpalte =    16;
  cmdarg:        BOOLEAN = FALSE;

CONST cPuffer =         High (WORD) - 1;
      cScreen =         (EndDisplay + 1 - StartDisplay) * EndSpalte * 2;
      cDisplay =        (EndDisplay - StartDisplay) * EndSpalte;
      MaxOffset =       cPuffer - cScreen;
TYPE
   einPufferP = ^einPuffer;
   einPuffer = ARRAY [0..cPuffer] OF BYTE;

   einModus = (ASCII, Hex, LInt, Mixed);

   einModusSet = SET OF einModus;

TYPE

  eineZeichentabelle =  ARRAY [Low (CHAR)..High (CHAR)] OF WORD;
  (* Tabelle fr die Zeichenposition im String (von hinten) *)
  Chset =      SET OF CHAR;

TYPE STRING2 = STRING [2];
     STRING4 = STRING [4];

VAR Puffer:         einPufferP;
    Dateiname:      STRING;
    Dateigroesse:   LONGINT;
    Start:          LONGINT;
    Offset:         LONGINT;
    Tabweite:       INTEGER;
    Tabexpand:      BOOLEAN;
    grosskleinEgal: BOOLEAN;
    nurWoerter:     BOOLEAN;
    TOOLBOOK:       BOOLEAN;
    Relativ:        BOOLEAN;
    Steuerzeichen:  BOOLEAN;
    Modus:          einModus;
    AdrModus:       einModus;
    such:           STRING;
    eingabe:        STRING;

PROCEDURE PufferLoeschen (VAR P: einPufferP);
BEGIN
  FillChar (P^, SizeOf (einPuffer), 0);
END;

PROCEDURE appendChar (VAR s: STRING; c: CHAR);
(* Aus c't 2/92 S. 162 *)
VAR   L:  BYTE ABSOLUTE s;
BEGIN
  IF L < 255 THEN BEGIN
    INC (L);
    S [L] := c;
  END (* IF *);
END (* appendChar *);

PROCEDURE appendString (VAR s1, s2: STRING);
VAR  L1:  BYTE ABSOLUTE s1;
     L2:  BYTE ABSOLUTE s2;
     j:   BYTE;
BEGIN
  FOR j := 1 TO L2 DO BEGIN
    IF L1 = 255 THEN EXIT;
    INC (L1);
    s1 [L1] := s2 [j];
  END (* FOR *);
END (* appendString *);

PROCEDURE HexByte (zahl: BYTE; VAR s: STRING2);
CONST  Ziffern:  ARRAY [0..15] OF CHAR = '0123456789ABCDEF';
BEGIN
  s[0] := #2;
  s[1] := Ziffern [zahl SHR 4];
  s[2] := Ziffern [zahl AND $0F];
END (* HexByte *);

PROCEDURE HexWord (zahl: WORD; VAR s: STRING4);
VAR  tricky:  RECORD
                CASE BOOLEAN OF
                  TRUE: (LowB, HiB: BYTE);
                  FALSE: (Wo: WORD);
              END;
     HiS, LoS: STRING2;
BEGIN
  tricky.Wo := zahl;
  HexByte (tricky.HiB, HiS);
  HexByte (tricky.LowB, LoS);
  s := His; appendString (s, Los);
END (* HexWord *);

FUNCTION StringVonNum (num: LONGINT): STRING;
VAR stri:  STRING [10];
BEGIN
  Str (num, stri);
  StringVonNum := stri;
END (* StringVonNum *);

FUNCTION StringVonNumF (num: LONGINT; f: INTEGER): STRING;
VAR stri:  STRING [80];
    i:     INTEGER;
BEGIN
  stri := StringVonNum (num);
  FOR i := LENGTH (stri) TO f DO
    Insert (' ', stri, 1);
  StringVonNumF := stri;
END (* StringVonNumF *);

FUNCTION StringVonError (err: WORD): STRING;
BEGIN
  CASE err OF
    0:    StringVonError := 'Normal termination';
    1:    StringVonError := 'Invalid DOS function number';
    2:    StringVonError := 'File not found';
    3:    StringVonError := 'Path not found';
    4:    StringVonError := 'Too many open files';
    5:    StringVonError := 'File access denied';
    6:    StringVonError := 'Invalid file handle';
    12:   StringVonError := 'Invalid file access mode';
    15:   StringVonError := 'Invalid drive number';
    16:   StringVonError := 'Cannot remove current directory';
    17:   StringVonError := 'Cannot rename across drives';
    18:   StringVonError := 'No more files';
    100:  StringVonError := 'Disk read error';
    101:  StringVonError := 'Disk write error';
    102:  StringVonError := 'File not assigned';
    103:  StringVonError := 'File not open';
    104:  StringVonError := 'File not open for input';
    105:  StringVonError := 'File not open for output';
    106:  StringVonError := 'Invalid numeric format';
    150:  StringVonError := 'Disk is write protected';
    151:  StringVonError := 'Unknown Unit (peripheral)';
    152:  StringVonError := 'Drive not ready';
    153:  StringVonError := 'Unknown DOS-command';
    154:  StringVonError := 'CRC error in data';
    155:  StringVonError := 'Bad drive request structure length';
    156:  StringVonError := 'Disk seek error';
    157:  StringVonError := 'Unknown media type';
    158:  StringVonError := 'Sector not found';
    159:  StringVonError := 'Printer out of paper';
    160:  StringVonError := 'Device write fault';
    161:  StringVonError := 'Device read fault';
    162:  StringVonError := 'Hardware failure';
    200:  StringVonError := 'Division by zero';
    201:  StringVonError := 'Range check error';
    202:  StringVonError := 'Stack overflow error';
    203:  StringVonError := 'Heap overflow error';
    204:  StringVonError := 'Invalid pointer operation (Dispose, Freemem)';
    205:  StringVonError := 'Floating point overflow';
    206:  StringVonError := 'Floating point underflow';
    207:  StringVonError := 'Invalid floating point operation';
    208:  StringVonError := 'Overlay manager not installed';
    209:  StringVonError := 'Overlay file read error';
    210:  StringVonError := 'Object not initialized';
    211:  StringVonError := 'Call to abstract method';
    212:  StringVonError := 'Stream registration error';
    213:  StringVonError := 'Collection index out of range';
    214:  StringVonError := 'Collection overflow error';
    215:  StringVonError := 'Arithmetic overflow error';
    216:  StringVonError := 'General Protection fault';
    1000: StringVonError := 'Error Test';
    {cmHalt: StringVonError := 'Abbruch durch Benutzer';}
  ELSE StringVonError := StringVonNum (err);
  END (* CASE *);

  (* Bemerkung: Kann durch HALT (x) oder RunError (x) erweitert werden! *)
END (* StringVonError *);

FUNCTION StringVonByte (zahl: BYTE): STRING;
VAR ByteStr: STRING [2];
BEGIN
  HexByte (zahl, ByteStr);
  StringVonByte := ByteStr;
END (* StringVonByte *);

FUNCTION HexVonString (s: STRING): STRING;
VAR  rs:      STRING;
     ByteStr: STRING [2];
     i:       INTEGER;
BEGIN
  rs := '';
  FOR i := 1 TO LENGTH (s) DO BEGIN
    HexByte (ORD (s [i]), ByteStr);
    AppendString (rs, ByteStr);
  END;
  HexVonString := rs;
END (* HexVonString *);

FUNCTION StringVonHex (zahl: WORD): STRING;
VAR HexStr: STRING [4];
BEGIN
  HexWord (zahl, HexStr);
  StringVonHex := HexStr;
END (* StringVonHex *);

FUNCTION StringVonLong (zahl: LONGINT): STRING;
VAR LongStr: STRING [9];
    LowStr, HiStr: STRING [4];
BEGIN
  HexWord (zahl MOD 65536, LowStr);
  HexWord (zahl DIV 65536, HiStr);
  LongStr := HiStr;
  appendChar (LongStr, ' '); appendString (LongStr, LowStr);
  StringVonLong := LongStr;
END (* StringVonLong *);

FUNCTION NumVonHex (hex: STRING): LONGINT;
VAR  wert:  LONGINT;
     i:     INTEGER;
BEGIN
  Wert := 0;
  FOR i := 1 TO LENGTH (hex) DO BEGIN
    IF hex [i] IN ['0'..'9'] THEN
      Wert := Wert * 16 + ORD (hex [i]) - ORD ('0')
    ELSE IF hex [i] IN ['a'..'f', 'A'..'F'] THEN
      Wert := Wert * 16 + ORD (UpCase (hex [i])) - ORD ('A') + 10;
  END (* FOR *);
  NumVonHex := wert;
END (* NumVonHex *);

FUNCTION StringVonPointer (p: POINTER): STRING;
VAR  tricky: RECORD
               CASE BOOLEAN OF
                 TRUE: (LowP, HiP: WORD);
                 FALSE: (poin: POINTER);
               END;
     LowS:  STRING [4];
     PS:    STRING [9];
BEGIN
  tricky.poin := p;
  HexWord (tricky.HiP, PS);
  appendChar (PS, ':');
  HexWord (tricky.LowP, LowS);
  appendString (PS, LowS);

  StringVonPointer := PS;
END (* StringVonPointer *);

FUNCTION atString (p: POINTER): STRING;
BEGIN
  atString := ' @' + StringVonPointer (p);
END (* atString *);

VAR Datei: FILE;

PROCEDURE LadePuffer (VAR Datei: FILE; Puffer: einPufferP; CONST Off: LONGINT);
VAR Result: WORD;
BEGIN
  Seek (Datei, Off);
  BlockRead (Datei, Puffer^, SizeOf (einPuffer), Result);
  IF Result < SizeOf (einPuffer) THEN
     FillChar (Puffer^[Result], SizeOf (einPuffer) - Result, 0);
END (* LadePuffer *);

  FUNCTION Sprung: LONGINT;
  BEGIN
    CASE Modus OF
      Hex:    Sprung := endSpalte;
      ASCII:  Sprung := endSpalte * 2;
      ELSE    Sprung := endSpalte;
    END (* CASE *);
  END (* Sprung *);

PROCEDURE DecOffs (VAR Offs, Sta: LONGINT; Betr: LONGINT);
VAR   ch:  CHAR;
BEGIN
  IF Offs >= Betr THEN DEC (Offs, Betr)
  ELSE BEGIN
    IF Sta >= CPuffer THEN BEGIN
(*
GotoXY (1, 1); Write ('DecOffs, Betr: ', Betr, ', Sta: ', Sta); ClrEol;
ch := readKey;
*)
      DEC (Sta, CPuffer - Sprung * endDisplay);
      Offs := CPuffer - Betr - Sprung * endDisplay;
      IF Sta + Offs > CPuffer THEN BEGIN
        INC (Sta, Betr); DEC (Offs, Betr);
      END;
    END
    ELSE BEGIN
      IF Offs > Betr THEN
        Offs := Sta + Offs - Betr
      ELSE BEGIN
        Offs := 0;
        IF Sta > Betr THEN DEC (Sta, Betr)
        ELSE Sta := 0;
      END (* inneres ELSE *);
    END (* ELSE *);
    LadePuffer (Datei, Puffer, Sta);
  END (* ELSE *);
END (* DecOffs *);

PROCEDURE IncOffs (VAR Offs, Sta: LONGINT; Betr: LONGINT);
BEGIN
  IF Offs + Betr <= MaxOffset THEN INC (Offs, Betr)
  ELSE BEGIN
    Sta := Sta + Betr + Offs; Offs := 0;
    LadePuffer (Datei, Puffer, Sta);
  END;
END (* IncOffs *);

PROCEDURE SetOffs (VAR Offs, Sta: LONGINT; Betr: LONGINT);
BEGIN
  IF Betr >= 0 THEN BEGIN
    Sta := Betr; Offs := 0;
    LadePuffer (Datei, Puffer, Sta);
  END (* IF Betr >= 0 *);
END (* SetOffs *);

FUNCTION LiesKurzwort (Index: LONGINT; Rel: BOOLEAN): LONGINT;
VAR  Wort: LONGINT;
BEGIN
  IF Index + 2 - Start > MaxOffset THEN SetOffs (Offset, Start, Index {+ 2});
  Wort := Puffer^[Index - Start];
  Wort := Wort SHL 8;
  Wort := Wort + Puffer^[Index + 1 - Start];
  IF Rel THEN Wort := Wort + Index;
  LiesKurzwort := Wort;
END (* LiesKurzwort *);

FUNCTION LiesLangwort (Index: LONGINT; Rel: BOOLEAN): LONGINT;
VAR  Wort: LONGINT;
BEGIN
  IF Index + 4 - Start > MaxOffset THEN SetOffs (Offset, Start, Index + 2);
  Wort := Puffer^[Index - Start];
  Wort := Wort SHL 8;
  Wort := Wort + Puffer^[Index + 1 - Start];
  Wort := Wort SHL 8;
  Wort := Wort + Puffer^[Index + 2 - Start];
  Wort := Wort SHL 8;
  Wort := Wort + Puffer^[Index + 3 - Start];
  IF Rel THEN Wort := Wort + Index;
  LiesLangwort := Wort;
END (* LiesLangwort *);

FUNCTION BackKurzwort (Index: LONGINT; Rel: BOOLEAN): LONGINT;
VAR  Wort: LONGINT;
BEGIN
  IF Index + 2 - Start > MaxOffset THEN SetOffs (Offset, Start, Index + 2);
  Wort := Puffer^[Index + 1 - Start];
  Wort := Wort SHL 8;
  Wort := Wort + Puffer^[Index - Start];
  IF Rel THEN Wort := Wort + Index;
  BackKurzwort := Wort;
END (* LiesKurzwort *);

FUNCTION BackLangwort (Index: LONGINT; Rel: BOOLEAN): LONGINT;
VAR  Wort: LONGINT;
BEGIN
  IF Index + 4 - Start > MaxOffset THEN SetOffs (Offset, Start, Index + 2);
  Wort := Puffer^[Index + 3 - Start];
  Wort := Wort SHL 8;
  Wort := Wort + Puffer^[Index + 2 - Start];
  Wort := Wort SHL 8;
  Wort := Wort + Puffer^[Index + 1 - Start];
  Wort := Wort SHL 8;
  Wort := Wort + Puffer^[Index - Start];
  IF Rel THEN Wort := Wort + Index;
  BackLangwort := Wort;
END (* LiesLangwort *);

PROCEDURE KopfZeile (CONST AdrMod: einModus; Offset: LONGINT;
                     CX, CY: INTEGER);
BEGIN
  GotoXY (1, KopfPos);
  IF AdrMod = LInt THEN BEGIN
    Write ('Curs: ', Offset + CX + CY * endSpalte, ', ');
    Write ('Datei: ', Dateiname, ', Gre Dez: ', Dateigroesse:10);
    GotoXY (1, KopfPos + 1);
    Write ('[', CX + CY * endSpalte, ']');
  END
  ELSE BEGIN
    Write ('Curs: ', StringVonLong (Offset + CX + CY * endSpalte), ' ');
    Write ('Datei: ', Dateiname, ', Gre Hex: ', StringVonLong (Dateigroesse));
    GotoXY (1, KopfPos + 1);
    Write ('[', StringVonHex (CX + CY * endSpalte), ']');
  END;
END (* KopfZeile *);

PROCEDURE FussZeile (CONST Modus, AdrMod: einModus);
VAR  Menu: STRING;
BEGIN
  GotoXY (1, FussPos);
  Menu := 'Quit, ';
  CASE Modus OF
    ASCII: Menu := Menu + 'Hex, Mix, ';
    Hex:   Menu := Menu + 'ASCII, Mix, ';
    Mixed: Menu := Menu + 'ASCII, Hex, ';
  END (* CASE *);
  CASE AdrMod OF
    Lint:  Menu := Menu + 'Wrdoff, ';
    Hex:   Menu := Menu + 'Intoff, ';
  END;
  IF grosskleinEgal THEN Menu := Menu + 'Grkl=egal, '
  ELSE Menu := Menu + 'Grkl=vsch, ';
  Menu := Menu + 'B/Suche, ';
  IF ANSIFiltern THEN Menu := Menu + 'FlANSI=EIN, '
  ELSE Menu := Menu + 'FlANSI=AUS, ';
  IF Tabexpand THEN Menu := Menu + 'Tbexp=EIN, '
  ELSE Menu := Menu + 'Tbexp=AUS, ';
  Menu := Menu + 'Offset: ';
  Write (Menu);
END (* FussZeile *);

PROCEDURE grossesMenue (CONST Modus, AdrMod: einModus;
                        Offset: LONGINT; CursX, CursY: INTEGER);
VAR  Menu: STRING;
BEGIN
  ClrScr;
  KopfZeile (AdrMod, Start + Offset, CursX, CursY);

  GotoXY (1, 3);
  WriteLn ('Inspektor ', cVersion:2:3); WriteLn;
  WriteLn ('Q(uit: Programm verlassen,          N(eue Datei whlen');
  WriteLn ('Esc: zurckschalten auf Dateidisplay');
  Menu := 'Darstellung umschalten auf: ';
  CASE Modus OF
    ASCII: Menu := Menu + 'H(ex, M(ix (ASCII + Hex)';
    Hex:   Menu := Menu + 'A(SCII, M(ix (ASCII + Hex)';
    Mixed: Menu := Menu + 'A(SCII, H(ex, ';
  END (* CASE *);
  WriteLn (Menu);
  Menu := 'Offset und Dateilnge darstellen als: ';
  CASE AdrMod OF
    Lint:  Menu := Menu + 'hexW(ord, ';
    Hex:   Menu := Menu + 'I(nteger, ';
  END;
  WriteLn (Menu);
  IF grosskleinEgal THEN Menu := 'G(roklein bei Suchen = egal'
  ELSE Menu := 'G(roklein bei Suchen wird unterschieden';
  IF nurWoerter THEN Menu := Menu + ', C: Wortsuche ist an'
  ELSE Menu := Menu + ', C: Wortsuche ist aus';
  Writeln (Menu);

  IF ANSIFiltern THEN Menu := 'F(iltere ANSI=EIN'
  ELSE Menu := 'F(iltere ANSI=AUS';
  IF Tabexpand THEN Menu := Menu + ', T(abs expandieren = EIN'
  ELSE Menu := Menu + ', Tabs expandieren = AUS';
  IF Steuerzeichen THEN Menu := Menu + ', X: Steuerzeichen anzeigen = EIN'
  ELSE Menu := Menu + ', X: Steuerzeichen anzeigen = AUS';
  WriteLn (Menu);
  Writeln ('O(ffset (Startadresse) des Displays neu whlen');

  WriteLn;
  WriteLn ('S(tring suchen, B(inr suchen (String aus Hexbytes, zB. "FA 09 E6")');
  WriteLn ('Y: Stichwort suchen (Duden-CD), V: Index neu einstellen');
  WriteLn ('D: Drucken, >: Speichern der Datei von-bis');

  WriteLn;
  WriteLn ('Blttern mit Cursortasten auf Numerik-Block (Numlock EIN!)');
  WriteLn ('Die Tasten <- -> ^ v, Pos1, Ende, Bild^, Bild-v bewegen den Index-Cursor');
  WriteLn ('<Tab> schaltet im Mixed-Modus den Cursor zwischen Hex/ASCI um');
  WriteLn ('K: Sprung zu Offset von Kurzwort, L: Sprung zu Offset von Langwort');
  WriteLn ('U: Sprung zu Offset von Kurzpointer, P: Sprung zu Offset von Pointer');
  WriteLn ('J: Jump zu Duden-Index (x 800H - 800H + Offs)');
  WriteLn ('E(rinnere diese Position (nach Cursorbewegung mit Z zurck)');
  WriteLn ('Z(urck zur letzten Position, auch nach Suchen');
  IF Relativ THEN WriteLn ('R(elativ springen = eingeschaltet')
  ELSE WriteLn ('R(elativ springen = ausgeschaltet');
END (* grossesMenue *);

PROCEDURE Display (P: einPufferP; Modus, AdrMod: einModus; Start: LONGINT;
                   Offset: LONGINT; CursX, CursY: INTEGER);
VAR  Zeile, Spalte:  WORD;
     Spalten:        WORD;
     Ind:            LONGINT;
     SchrInd, I:     INTEGER;
     ch:             CHAR;
BEGIN
  ClrScr;
  KopfZeile (AdrMod, Start + Offset, CursX, CursY);

  CASE Modus OF
    Hex: BEGIN
           Spalten := EndSpalte;
             GotoXY (SpaltenOff, StartDisplay);
             FOR Spalte := StartSpalte - 1 TO Spalten - 1 DO BEGIN
               Write (StringVonByte (Spalte), ' ');
               IF Spalte = 7 THEN Write ('  ');
             END;
           FOR Zeile := 0  TO EndDisplay - StartDisplay - 1 DO BEGIN
             GotoXY (StartSpalte, Zeile + StartDisplay + 1);
             IF AdrMod = LInt THEN
               Write (StringVonNum (Start + Offset + (Zeile * Spalten)), ':')
             ELSE
               Write (StringVonLong (Start + Offset + (Zeile * Spalten)), ':');
             SchrInd := SpaltenOff;
             FOR Spalte := StartSpalte - 1 TO Spalten - 1 DO BEGIN
               GotoXY (SchrInd, Zeile + StartDisplay + 1);
               Write (StringVonByte (P^[Offset + Zeile * Spalten + Spalte]));
               IF Spalte = 7 THEN BEGIN
                 Write (' |'); INC (SchrInd, 5);
               END
               ELSE INC (SchrInd, 3);
             END (* FOR *);
           END (* FOR Zeile *);
         END (* Hex *);
    ASCII: BEGIN
             Spalten := 80; Zeile := 0;
             Ind := Offset;
             WHILE Zeile <= EndDisplay - StartDisplay DO BEGIN
               GotoXY (StartSpalte, Zeile + StartDisplay);
               IF AdrMod = LInt THEN
                 Write (StringVonNum (Start + Ind), ':')
               ELSE
                 Write (StringVonLong (Start + Ind), ':');

               SchrInd := SpaltenOff;
               WHILE SchrInd < Spalten DO BEGIN
                 GotoXY (SchrInd, Zeile + StartDisplay);
                 IF P^[Ind] >= ORD (' ') THEN BEGIN
                   Write (ANSIFil (CHR (P^[Ind]))); INC (SchrInd);
                 END
                 ELSE IF CHR (P^[Ind]) = Nulch THEN BEGIN
                   Write (''); INC (SchrInd);
                 END
                 ELSE BEGIN
                   IF (CHR (P^[Ind]) = tabch) AND Tabexpand THEN BEGIN
                     FOR I := SchrInd TO Tabweite * ((SchrInd - Spaltenoff) DIV Tabweite + 1) + Spaltenoff - 1
                     DO BEGIN
                       Write (TabPfeil); INC (SchrInd);
                     END (* FOR *);
                   END (* IF Tab *)
                   ELSE BEGIN
                     IF Steuerzeichen THEN BEGIN
                       Write ('^', CHR (P^[Ind] + ORD ('@')));
                       INC (SchrInd, 2);
                     END (* IF Steuerzeichen *);
                   END (* ELSE kein Tab *);
                 END;
                 IF (CHR (P^[Ind]) IN [crch, lfch]) THEN BEGIN
                   IF (CHR (P^[Ind]) = crch) THEN BEGIN
                      INC (Ind);
                      IF CHR (P^[Ind]) = lfch THEN BEGIN
                        Write ('^', CHR (P^[Ind] + ORD ('@')));
                        INC (Ind);
                      END (* IF lf *);
                   END (* LF berlesen *)
                   ELSE INC (Ind);
                   Break;
                 END;
                 INC (Ind);
                 IF Ind >= cPuffer THEN BEGIN
                   SetOffs (Offset, Start, Start + Ind);
                   Ind := Offset;
                 END (* IF Pufferberlauf *);
               END (* WHILE Spalte *);
               INC (Zeile);
             END (* WHILE Zeile *);
           END;
    Mixed: BEGIN
             Spalten := EndSpalte;
             GotoXY (SpaltenOff, StartDisplay);
             FOR Spalte := StartSpalte - 1 TO Spalten - 1 DO BEGIN
               Write (StringVonByte (Spalte), ' ');
               IF Spalte = 7 THEN Write ('  ');
             END;
             FOR Zeile := 0 TO EndDisplay - StartDisplay - 1 DO BEGIN
               GotoXY (StartSpalte, Zeile + StartDisplay + 1);
               IF AdrMod = LInt THEN
                 Write (StringVonNum (Start + Offset + (Zeile * Spalten)))
               ELSE
                 Write (StringVonLong (Start + Offset + (Zeile * Spalten)), ':');
               SchrInd := SpaltenOff;
               (* Hex *)
               FOR Spalte := StartSpalte - 1 TO Spalten - 1 DO BEGIN
{GotoXY (1, 1); Write ('Offset + Zeile * Spalten + Spalte: ',
                       Offset + Zeile * Spalten + Spalte); ClrEol;
ch := readKey;
}
                 GotoXY (SchrInd, Zeile + StartDisplay + 1);
                 Write (StringVonByte (P^[Offset + Zeile * Spalten + Spalte]));
                 IF Spalte = 7 THEN BEGIN
                   Write (' |'); INC (SchrInd, 5);
                 END
                 ELSE INC (SchrInd, 3);
               END (* FOR *);
               GotoXY (SchrInd, Zeile + StartDisplay + 1);
               (* ASCII *)
               FOR Spalte := StartSpalte - 1 TO Spalten - 1 DO BEGIN
                 Ind := Offset + Zeile * Spalten + Spalte;
                 IF P^[Ind] >= ORD (' ') THEN BEGIN
                   Write (ANSIFil (CHR (P^[Ind])));
                 END
                 ELSE BEGIN Write ('');
                 END;
                 INC (SchrInd);
               END (* FOR *);
             END (* FOR Zeile *);
           END;
  END (* CASE *);
  FussZeile (Modus, AdrMod);
END (* Display *);

PROCEDURE Drucken (P: einPufferP; Modus, AdrMod: einModus; Offset: LONGINT;
                   CursX, CursY: INTEGER);
VAR  Zeile, Spalte:    LONGINT;
     DruckZeile:       LONGINT;
     Seite:            LONGINT;
     Spalten:          INTEGER;
     Ind:              LONGINT;
     SchrInd, I:       INTEGER;
     StartOff, EndOff: LONGINT;
     HexString:        STRING [10];
     Drucker:          TEXT;
     Druckausgabe:     STRING;
     ch:               CHAR;
BEGIN
  KopfZeile (AdrModus, Start + Offset, CursX, CursY); WriteLn;
  Write ('Offset fr Druckbeginn (0 = Bildschirmstart): '); ClrEol;
  IF AdrModus = LInt THEN ReadLn (StartOff)
  ELSE IF AdrModus = Hex THEN BEGIN
    ReadLn (HexString);
    StartOff := NumVonHex (HexString);
  END
  ELSE StartOff := 0;
  IF StartOff = 0 THEN StartOff := Start + Offset;

  KopfZeile (AdrModus, Start + Offset, CursX, CursY); WriteLn;
  Write ('Offset fr Druckende (0 = Dateiende): '); ClrEol;
  IF AdrModus = LInt THEN ReadLn (EndOff)
  ELSE IF AdrModus = Hex THEN BEGIN
    ReadLn (HexString);
    EndOff := NumVonHex (HexString);
  END
  ELSE EndOff := 0;
  IF EndOff = 0 THEN EndOff := Dateigroesse;

  KopfZeile (AdrModus, Start + Offset, CursX, CursY); WriteLn;
  Write ('Druckausgebe (RET fr ', DefaultDrucker, '): '); ClrEol;
  ReadLn (Druckausgabe);
  IF Druckausgabe = '' THEN Druckausgabe := DefaultDrucker;

  Assign (Drucker, Druckausgabe);
  Rewrite (Drucker);

  SetOffs (Offset, Start, StartOff);

  Seite := 1; Zeile := 0; Ind := Offset;

  REPEAT
    DruckZeile := 1;
    CASE Modus OF
      Hex: BEGIN
             Spalten := EndSpalte;
              Ind := Offset;

               (* berschrift *)
               Write (Drucker, Druckeinrueck, 'Inspektor ', cVersion:2:3, ' ');
               IF AdrMod = LInt THEN
                 Write (Drucker, 'Datei: ', Dateiname, ', Gre Dez: ', Dateigroesse:10)
               ELSE
                 Write (Drucker, 'Datei: ', Dateiname, ', Gre Hex: ', StringVonLong (Dateigroesse));
               WriteLn (Drucker, ' - ', Seite, ' -');
               INC (Druckzeile);
               WriteLn (Drucker); INC (DruckZeile);
               WriteLn (Drucker); INC (DruckZeile);

               Write (Drucker, Druckeinrueck, ' ':12);
               FOR Spalte := StartSpalte - 1 TO Spalten - 1 DO BEGIN
                 Write (Drucker, StringVonByte (Spalte), ' ');
                 IF Spalte = 7 THEN Write (Drucker, '  ');
               END;
               WriteLn (Drucker); INC (Druckzeile);

             WHILE DruckZeile <= DruckZeilen DO BEGIN
               IF AdrMod = LInt THEN
                 Write (Drucker, Druckeinrueck, StringVonNum (Start + Offset + (Zeile * Spalten)):10, ':  ')
               ELSE
                 Write (Drucker, Druckeinrueck, StringVonLong (Start + Offset + (Zeile * Spalten)), ':  ');
               FOR Spalte := StartSpalte - 1 TO Spalten - 1 DO BEGIN
                 Write (Drucker, StringVonByte (P^[Offset + Zeile * Spalten + Spalte]),' ');
                 IF Spalte = 7 THEN BEGIN
                   Write (Drucker, '| '); {INC (SchrInd, 5);}
                 END;
               END (* FOR *);
               WriteLn (Drucker);
               INC (Druckzeile); INC (StartOff, Spalten);
               IF Offset + Zeile * Spalten + Spalten >= cPuffer THEN BEGIN
                 SetOffs (Offset, Start, StartOff);
                 Display (Puffer, Modus, AdrModus, Start, Offset, CursX, CursY);
               END;
               INC (Zeile);
             END (* WHILE Zeile *);
           END (* Hex *);
      ASCII: BEGIN
               Spalten := 80; Zeile := 0;

               (* berschrift *)
               Write (Drucker, Druckeinrueck, 'Inspektor ', cVersion:2:3, ' ');
               IF AdrMod = LInt THEN
                 Write (Drucker, 'Datei: ', Dateiname, ', Gre Dez: ', Dateigroesse:10)
               ELSE
                 Write (Drucker, 'Datei: ', Dateiname, ', Gre Hex: ', StringVonLong (Dateigroesse));
               WriteLn (Drucker, ' - ', Seite, ' -');
               INC (Druckzeile);

               WriteLn (Drucker); INC (DruckZeile);
               WriteLn (Drucker); INC (DruckZeile);

               Zeile := DruckZeile;

               WHILE Zeile <= DruckZeilen DO BEGIN
                 IF AdrMod = LInt THEN
                   Write (Drucker, Druckeinrueck, StringVonNum (Start + Ind):10, ':  ')
                 ELSE
                   Write (Drucker, Druckeinrueck, StringVonLong (Start + Ind), ':  ');

                 SchrInd := SpaltenOff;
                 WHILE SchrInd < Spalten DO BEGIN
                   IF P^[Ind] >= ORD (' ') THEN BEGIN
                     Write (Drucker, ANSIFil (CHR (P^[Ind]))); INC (SchrInd);
                   END
                   ELSE IF CHR (P^[Ind]) = Nulch THEN BEGIN
                     Write (Drucker, ''); INC (SchrInd);
                   END
                   ELSE BEGIN
                     IF (CHR (P^[Ind]) = tabch) AND Tabexpand THEN BEGIN
                       FOR I := SchrInd TO Tabweite * ((SchrInd - Spaltenoff) DIV Tabweite + 1) + Spaltenoff - 1
                       DO BEGIN
                         Write (Drucker, TabPfeil); INC (SchrInd);
                       END (* FOR *);
                     END (* IF Tab *)
                     ELSE BEGIN
                       IF Steuerzeichen THEN BEGIN
                         Write (Drucker, '^', CHR (P^[Ind] + ORD ('@')));
                         INC (SchrInd, 2);
                       END (* IF Steuerzeichen *);
                     END (* ELSE kein Tab *);
                   END;
                   IF CHR (P^[Ind]) IN [crch, lfch] THEN BEGIN
                     IF (CHR (P^[Ind]) = crch) THEN BEGIN
                        INC (Ind); INC (StartOff);
                        IF CHR (P^[Ind]) = lfch THEN BEGIN
                          Write (Drucker, '^', CHR (P^[Ind] + ORD ('@')));
                          INC (Ind); INC (StartOff);
                        END (* IF lf *);
                     END (* LF berlesen *)
                     ELSE BEGIN INC (Ind); INC (StartOff); END;
                     Break;
                   END;
                   INC (Ind); INC (StartOff);
                   IF Ind >= cPuffer THEN BEGIN
                     SetOffs (Offset, Start, StartOff);
                     Ind := Offset;
                     Display (Puffer, Modus, AdrModus, Start, Offset, CursX, CursY);
                   END (* IF Pufferberlauf *);
                 END (* WHILE Spalte *);
                 INC (Zeile);
                 WriteLn (Drucker); INC (DruckZeile);
               END (* WHILE Zeile *);
             END;
      Mixed: BEGIN
               Spalten := EndSpalte;
               Ind := Offset;

               (* berschrift *)
               Write (Drucker, Druckeinrueck, 'Inspektor ', cVersion:2:3, ' ');
               IF AdrMod = LInt THEN
                 Write (Drucker, 'Datei: ', Dateiname, ', Gre Dez: ', Dateigroesse:10)
               ELSE
                 Write (Drucker, 'Datei: ', Dateiname, ', Gre Hex: ', StringVonLong (Dateigroesse));
               WriteLn (Drucker, ' - ', Seite, ' -');
               INC (Druckzeile);

               WriteLn (Drucker); INC (DruckZeile);
               WriteLn (Drucker); INC (DruckZeile);

               Write (Drucker, Druckeinrueck, ' ':12);
               FOR Spalte := StartSpalte - 1 TO Spalten - 1 DO BEGIN
                 Write (Drucker, StringVonByte (Spalte), ' ');
                 IF Spalte = 7 THEN Write (Drucker, '  ');
               END;
               WriteLn (Drucker); INC (Druckzeile);

               WHILE DruckZeile <= DruckZeilen DO BEGIN
                 IF AdrMod = LInt THEN
                   Write (Drucker, Druckeinrueck, StringVonNum (Start + Offset + (Zeile * Spalten)):10, ':  ')
                 ELSE
                   Write (Drucker, Druckeinrueck, StringVonLong (Start + Offset + (Zeile * Spalten)), ':  ');

                 (* Hex *)
                 FOR Spalte := StartSpalte - 1 TO Spalten - 1 DO BEGIN
                   Write (Drucker, StringVonByte (P^[Offset + Zeile * Spalten + Spalte]), ' ');
                   IF Spalte = 7 THEN BEGIN
                     Write (Drucker, '| '); INC (SchrInd, 5);
                   END
                   ELSE INC (SchrInd, 3);
                 END (* FOR *);
                 Write (Drucker, ' ');

                 (* ASCII *)
                 FOR Spalte := StartSpalte - 1 TO Spalten - 1 DO BEGIN
                   Ind := Offset + Zeile * Spalten + Spalte;
                   IF P^[Ind] >= ORD (' ') THEN BEGIN
                     Write (Drucker, ANSIFil (CHR (P^[Ind])));
                   END
                   ELSE BEGIN Write (Drucker, '');
                   END;
                   INC (SchrInd);
                 END (* FOR *);
                 WriteLn (Drucker);
                 INC (DruckZeile); INC (StartOff, Spalten);
                 IF Offset + Zeile * Spalten + Spalten >= cPuffer THEN BEGIN
                   SetOffs (Offset, Start, StartOff);
                   Display (Puffer, Modus, AdrModus, Start, Offset, CursX, CursY);
                 END;
                 INC (Zeile);
               END (* WHILE Zeile *);
             END;
    END (* CASE *);
    INC (Seite); Write (Drucker, FFch);
    IF keypressed THEN BEGIN ch := ReadKey; Break; END;
  UNTIL (StartOff >= EndOff);
  Write (Drucker, FFch);
  Close (Drucker);
END (* Drucken *);

PROCEDURE Speichern (P: einPufferP; Modus, AdrMod: einModus; Offset: LONGINT;
                   CursX, CursY: INTEGER);
VAR  Zeile, Spalte:    LONGINT;
     DruckZeile:       LONGINT;
     Seite:            LONGINT;
     Spalten:          INTEGER;
     Ind:              LONGINT;
     SchrInd:          INTEGER;
     StartOff, EndOff: LONGINT;
     HexString:        STRING [10];
     Ausgabe:          TEXT;
     Dateiausgabe:     STRING;
     ch:               CHAR;
     {buf:              ARRAY [0..4095] OF CHAR;}

BEGIN
  KopfZeile (AdrModus, Start + Offset, CursX, CursY); WriteLn;
  Write ('Offset fr Dateibeginn (0 = Bildschirmstart): '); ClrEol;
  IF AdrModus = LInt THEN ReadLn (StartOff)
  ELSE IF AdrModus = Hex THEN BEGIN
    ReadLn (HexString);
    StartOff := NumVonHex (HexString);
  END
  ELSE StartOff := 0;
  IF StartOff = 0 THEN StartOff := Start + Offset;

  KopfZeile (AdrModus, Start + Offset, CursX, CursY); WriteLn;
  Write ('Offset fr Dateiende (0 = Dateiende): '); ClrEol;
  IF AdrModus = LInt THEN ReadLn (EndOff)
  ELSE IF AdrModus = Hex THEN BEGIN
    ReadLn (HexString);
    EndOff := NumVonHex (HexString);
  END
  ELSE EndOff := 0;
  IF EndOff = 0 THEN EndOff := Dateigroesse;

  KopfZeile (AdrModus, Start + Offset, CursX, CursY); WriteLn;
  Write ('Dateiausgebe (RET fr ', DefaultDrucker, '): '); ClrEol;
  ReadLn (Dateiausgabe);
  IF Dateiausgabe = '' THEN Dateiausgabe := DefaultDrucker;

  Assign (Ausgabe, Dateiausgabe);
  {SetTextBuf (Ausgabe, buf);}
  Rewrite (Ausgabe);

  SetOffs (Offset, Start, StartOff);

  Seite := 1; Zeile := 0; Ind := Offset; SchrInd := 0;

  REPEAT
  {
    DruckZeile := 1;

    Spalten := 80; Zeile := 0;

    Zeile := DruckZeile;
   }
        IF P^[Ind] >{=} ORD (' ') THEN BEGIN
          IF NOT (CHR (P^[Ind]) IN ['!', '"', ',', ';', '.', ':', '|',
                                    '(', ')', '=', '[', ']', '{', '}',
                                    '<', '>',
                                    #$B2, #$B6, #$B9]) THEN
            {Write (Ausgabe, ANSIFil (CHR (P^[Ind])));}
            Write (Ausgabe, CHR (P^[Ind]));
            INC (SchrInd);
        END
        ELSE IF CHR (P^[Ind]) = Nulch THEN BEGIN
          {Write (Ausgabe, '');}
        END
        ELSE IF P^[Ind] = $1F THEN BEGIN
          INC (Ind); INC (StartOff);
          IF CHR (P^[Ind]) = 'A' THEN BEGIN
            INC (Ind); INC (StartOff);
          END (* IF lf *)
          ELSE IF SchrInd > 0 THEN BEGIN
            WriteLn (Ausgabe); SchrInd := 0;
          END (* ELSE *);
        END
        ELSE IF CHR (P^[Ind]) IN [crch, lfch, ' '] THEN BEGIN
          IF SchrInd > 0 THEN BEGIN
            WriteLn (Ausgabe); SchrInd := 0;
          END;
        {
          IF (CHR (P^[Ind]) = tabch) AND Tabexpand THEN BEGIN
            FOR I := SchrInd TO Tabweite * ((SchrInd - Spaltenoff) DIV Tabweite + 1) + Spaltenoff - 1
            DO BEGIN
              Write (Ausgabe, TabPfeil); INC (SchrInd);
            END (* FOR *);
          END (* IF Tab *)
          ELSE BEGIN
            IF Steuerzeichen THEN BEGIN
              Write (Ausgabe, '^', CHR (P^[Ind] + ORD ('@')));
              INC (SchrInd, 2);
            END (* IF Steuerzeichen *);
          END (* ELSE kein Tab *);
        }
        END;
        {
        IF CHR (P^[Ind]) IN [crch, lfch] THEN BEGIN
          IF (CHR (P^[Ind]) = crch) THEN BEGIN
             INC (Ind); INC (StartOff);
             IF CHR (P^[Ind]) = lfch THEN BEGIN
               WriteLn (Ausgabe);
               INC (Ind); INC (StartOff);
             END (* IF lf *);
          END (* LF berlesen *)
          ELSE BEGIN INC (Ind); INC (StartOff); END;
          (*Break;*)
        END;
        }
        INC (Ind); INC (StartOff);
        IF Ind >= cPuffer THEN BEGIN
          SetOffs (Offset, Start, StartOff);
          Ind := Offset;
          Display (Puffer, Modus, AdrModus, Start, Offset, CursX, CursY);
        END (* IF Pufferberlauf *);

    IF keypressed THEN BEGIN ch := ReadKey; Break; END;
  UNTIL (StartOff >= EndOff);
  Close (Ausgabe);
END (* Speichern *);

FUNCTION Cap (CONST gk: BOOLEAN; CONST ch: CHAR): CHAR;
BEGIN
  IF gk THEN BEGIN
    CASE ch OF
      '':  Cap := '';
      '':  Cap := '';
      '':  Cap := '';
      ELSE Cap := UpCase (ch);
    END (* CASE *);
  END
  ELSE Cap := ch;
END (* Cap *);

PROCEDURE Caps (VAR s: STRING);
VAR i: INTEGER;
BEGIN
  FOR i := 1 TO LENGTH (s) DO
    s [i] := UpCase (s [i]);
END (* Caps *);

FUNCTION HexNachString (hex: STRING): STRING;
VAR s:      STRING;
    i, ind: INTEGER;
    Hi:     BOOLEAN;
    b, w:   BYTE;

  PROCEDURE AddNibble;
  BEGIN
    IF Hi THEN BEGIN
      b := b * 16 + w;
      AppendChar (s, CHR (b));
      b := 0; Hi := FALSE;
    END (* IF Hi *)
    ELSE BEGIN b := w; Hi := TRUE; END;
  END (* AddNibble *);

BEGIN (* HexNachString *)
  s := '';
  Caps (hex);
  i := 1;
  Hi := FALSE; b := 0;
  WHILE i <= LENGTH (hex) DO BEGIN
    IF hex [i] IN ['0'..'9'] THEN BEGIN
      w := ORD (hex [i]) - ORD ('0');
      AddNibble;
    END (* IF Ziffer *)
    ELSE IF hex [i] IN ['A'..'F'] THEN BEGIN
      w := ORD (hex [i]) - ORD ('A') + 10;
      AddNibble;
    END (* IF Buchstabe *);
    INC (i);
  END (* WHILE *);
  HexNachString := s;
END (* HexNachString *);

PROCEDURE macheSuchtabelle (VAR t: eineZeichentabelle;
                            VAR Suchbegriff: STRING; (* Var wg. CAPS *)
                            CONST grosskleinEgal: BOOLEAN);
VAR  Suchlaenge: WORD;
     dummy:      CHAR;
     j:          WORD;
BEGIN
  Suchlaenge := LENGTH (Suchbegriff);
  IF grosskleinEgal THEN Caps (Suchbegriff);
  (* Initialisieren der Suchtabelle: Fr jedes Zeichen, das im
     Suchstring vorkommt, wird festgehalten, wie weit sein letztes
     Vorkommen vom Ende des Strings entfernt ist. Zunchst wird die
     Tabelle mit der Suchlnge vorinitialisiert (fr die Zeichen,
     die nicht im String vorkommen). *)
  FOR dummy := Low (CHAR) TO High (Char) DO BEGIN
    t [dummy] := Suchlaenge;
  END (* FOR *);
  FOR j := 1 TO Suchlaenge - 1 DO BEGIN
    t [Suchbegriff [j]] := Suchlaenge - j;
  END (* FOR *);
END (* macheSuchtabelle *);

{$R-,Q-,S-,I-}
FUNCTION SPos (CONST Sstart: WORD; CONST Suchstr: STRING;
                          CONST Tabelle: eineZeichentabelle;
                          CONST gk, wort: BOOLEAN;
                          CONST Modus: einModus;
                          CONST dieZeichen: ChSet;
                          CONST derString: einPufferP;
                          CONST CursX, CursY: INTEGER): LONGINT;
VAR  k, j:         WORD;
     index:        LONGINT;
     ch:           CHAR;
     worttest:     BOOLEAN;
     neuind:       LONGINT;

  FUNCTION doWorttest: BOOLEAN;
  BEGIN
    IF NOT wort THEN doWorttest := TRUE
    ELSE BEGIN
{zeigMeldung ('Worttest', 'k = ' + StringVonNum (k) + ', index = ' + StringVonNum (index));}
      doWorttest := ((k <= 0) OR
                  (CHR (derString^ [k]) IN dieZeichen)) AND
                 ((index = Dateigroesse) OR
                  (CHR (derString^ [index]) IN dieZeichen));
    END (* ELSE *);
  END (* doWorttest *);

BEGIN {Spos}
  index := LENGTH (Suchstr) + Sstart;
  (* Index, bei dem die Suche startet (Wortende) *)
  REPEAT
    j := LENGTH (Suchstr) + 1; k := index; (* Laufindizes setzen *)
    REPEAT
      DEC (k); DEC (j);
    UNTIL (j < 1) OR (Suchstr [j] <> Cap (gk, CHR (derString^ [k])));
    (* vergleicht Suchstring [j] mit str [k] bis Ungleichheit oder
       Suchstring erschpft *)
    worttest := (j < 1) AND doWortTest;
    IF NOT worttest THEN BEGIN
      INC (index, Tabelle [Cap (gk, CHR (derString^ [index - 1]))]);
      IF index >= cPuffer THEN BEGIN
        neuind := index;
        SetOffs (Offset, Start, Start + LONGINT (neuind - LENGTH (Suchstr)));
        Display (derString, Mixed, AdrModus, Start, Offset, CursX, CursY);
        GotoXY (1, 1);
        IF Modus = Hex THEN
          Write ('Ich suche "$', HexVonString (suchStr), '"')
        ELSE Write ('Ich suche "', suchStr, '"');
        ClrEol;
        index := LENGTH (Suchstr);
      END (* IF *)
    END (* IF j *);
    IF (index MOD 10000 = 0) AND keypressed THEN BEGIN
      SPos := -1; EXIT;
    END;
{GotoXY (1, 1); Write ('Index: ', Index, ', Start: ', Start, ', Dateigroesse: ', Dateigroesse);}
  UNTIL (j < 1) OR (index + Start > Dateigroesse);
  IF (j < 1) AND (index + Start <= Dateigroesse) AND (worttest) THEN
    SPos := index - LENGTH (Suchstr) + Start
  ELSE SPos := -1;
END (* SPos *);
{$R+,Q+,S+,I+}

FUNCTION CursorIndex (CursX, CursY: INTEGER): LONGINT;
BEGIN
  CursorIndex := Offset + CursX + CursY * endSpalte;
END (* CursorIndex *);

FUNCTION Suchen (VAR such: String; Filtern: BOOLEAN; Modus: einModus;
                  VAR CursX, CursY: INTEGER): BOOLEAN;
VAR  s:         STRING;
     Tabelle:   eineZeichentabelle;
     Suchindex: LONGINT;
     i:         INTEGER;
     Suchstart: LONGINT;
BEGIN
  GotoXY (1, 1); ClrEol; Suchstart := CursorIndex (CursX, CursY);
  IF Modus = ASCII THEN
    Write ('Suchbegriff (', such, ') in ASCII: ')
  ELSE
    Write ('Suchstring ($', HexVonString (such), ') in Hex: ');
  ReadLn (s);
  IF s <> '' THEN BEGIN
    such := s;
    IF Modus = Hex THEN BEGIN such := HexNachString (such) END
    ELSE IF Filtern THEN BEGIN
      FOR i := 1 TO LENGTH (such) DO
        such [i] := ASCIIFil (such [i]);
    END (* ELSE *);
  END (* IF neue Eingabe *)
  ELSE INC (Suchstart);
  IF such = '' THEN EXIT;
  GotoXY (1, 1);
  IF Modus = ASCII THEN Write ('Ich suche "', such, '"')
  ELSE Write ('Ich suche "$', HexVonString (such), '"');
  ClrEol;
  macheSuchtabelle (Tabelle, such, grosskleinEgal);
  Suchindex := SPos (Suchstart, such, Tabelle, grosskleinEgal, nurWoerter, Modus,
                     [Nulch, ' ', ',', '.'], Puffer, {Offset,} CursX, CursY);
  IF Suchindex > 0 THEN BEGIN
    SetOffs (Offset, Start, Suchindex);
    CursX := 0; CursY := 0;
    Suchen := TRUE;
  END
  ELSE BEGIN
    GotoXY (1, 1);
    IF Modus = ASCII THEN Write ('Nicht gefunden: "', such, '"')
    ELSE Write ('Nicht gefunden: "$', HexVonString (such), '"');
    ClrEol;
    ReadLn;
    Suchen := FALSE;
  END;
END (* Suchen *);

PROCEDURE DateiOeffnen (VAR Datei: FILE;
                        VAR Name: STRING; Groesse: LONGINT;
                        Puffer: einPufferP);
VAR  IORes:   INTEGER;
     Einname: STRING;
BEGIN
  Einname := Name;
  REPEAT
    IF Einname = '' THEN BEGIN
      ClrScr; Write ('Pfadname der Datei (nur ENTER behlt alte Datei): ');
      ReadLn (Einname);
    END;
    IF Einname = '' THEN EXIT;
    Name := Einname;
    PufferLoeschen (Puffer);
    Dateigroesse := 0;
    Offset := 0; Start := 0;
{$I-}
    Close (Datei);
    IORes := IOResult; (* Interessiert nicht - ev. war keine Datei offen *)
    Assign (Datei, Name);
    Reset (Datei, 1);
    IORes := IOResult;
{$I+}
    IF IORes <> 0 THEN BEGIN
      WriteLn; Write ('Error: ', StringVonError (IORes)); ReadLn;
      Einname := '';
    END;
  UNTIL (IORes = 0);
  IF IORes = 0 THEN BEGIN
    LadePuffer (Datei, Puffer, 0);
    Dateigroesse := FileSize (Datei);
  END;
END (* DateiOeffnen *);

VAR
     NeuOff:        LONGINT;
     AltOff:        LONGINT;
     AltX, AltY:    INTEGER;

PROCEDURE Jump (VAR CursX, CursY: INTEGER);
VAR    Wort0, Wort1:  LONGINT;
BEGIN
  Wort0 := LiesKurzwort (Start + Offset + CursX + CursY * endSpalte, FALSE);
  Wort1 := LiesKurzwort (Start + Offset + CursX + 2 + CursY * endSpalte, FALSE);
  NeuOff := Wort0 * $800 - $800 + Wort1;
  AltX := CursX; AltY := CursY; CursX := 0; CursY := 0;
  AltOff := Start + Offset;
  SetOffs (Offset, Start, NeuOff);
END (* Jump *);

PROCEDURE macheIndex;
CONST TextStart:     LONGINT = $00000800;
      TextEnd:       LONGINT = $01386000;
      CursX:         INTEGER = 0;
      CursY:         INTEGER = 0;
      head:          STRING = #$1F#$41#$00#$00;
      tail:          STRING = #$20#$1F#$61#$1F#$0A;

VAR   headTabelle:   eineZeichentabelle;
      tailTabelle:   eineZeichentabelle;
      i:             INTEGER;

BEGIN
  SetOffs (Offset, Start, TextStart);
  Display (Puffer, Modus, AdrModus, Start, Offset, CursX, CursY);
  macheSuchtabelle (headTabelle, head, FALSE);
  FOR i := 1 TO 10 DO BEGIN

  END (* FOR *);
END (* macheIndex *);

PROCEDURE Blaettern (VAR Modus, AdrModus: einModus);
VAR  bef:           CHAR;
     key:           CHAR;
     HexString:     STRING [10];
     grossMenu:     BOOLEAN;
     CursX, CursY:  INTEGER;
     CursModus:     einModus;
     Suchwort:      STRING;

CONST CstartX = SpaltenOff;
      CstartY = StartDisplay + 1;
      CendX =   EndSpalte - 1;
      CendY =   EndDisplay - StartDisplay - 1;
      CMitte =  SpaltenOff + EndSpalte DIV 2 * 3;

  PROCEDURE CursorXY (X, Y: INTEGER; Modus: einModus);
  BEGIN
    CASE Modus OF
      ASCII: BEGIN
               INC (Y, StartDisplay);
               x := x + SpaltenOff;
             END;
      Hex:   BEGIN
               INC (Y, StartDisplay + 1);
               X := X * 3 + SpaltenOff;
               IF X >= cMitte THEN INC (X, 2);
             END;
      Mixed: BEGIN
              INC (Y, StartDisplay + 1);
              X := X + SpaltenOff + 3 * EndSpalte + 2;
             END;
    END (* CASE *);
    GotoXY (X, Y);
  END (* CursorXY *);

CONST
  DudenIndex:           LONGINT =     $0139E000;
  {DudenIndex:           LONGINT =     $0139E054;}
  {DudenIndex:           LONGINT =     $0139EB74;}
  LetzterDudenInd:      LONGINT =     $0187D96C;
  IndexOffset:          LONGINT =     $28;
  ArtikelOffset:        LONGINT =     $1E;
  StichwortOffset:      LONGINT =     $24;

  Seite:                LONGINT =     $800;
  Seitennetto:          LONGINT =     $800 - $30;
  Seitenrest:           LONGINT =     $30;
    (* der letzte Eintrag in der Seite ist offenbar immer leer *)

  PROCEDURE IndexEinstellen;
  BEGIN
    GotoXY (1, 1); ClrEol;
    Write ('Indexstart: (Hex) '); ReadLn (HexString);
    DudenIndex := NumVonHex (HexString);
    GotoXY (1, 1); ClrEol;
    Write ('Indexende: (Hex) '); ReadLn (HexString);
    LetzterDudenInd := NumVonHex (HexString);
  END (* IndexEinstellen *);

VAR
  UntereSchranke:       LONGINT;
  ObereSchranke:        LONGINT;
  off:                  LONGINT;

TYPE einVergleich =     (nichtvorhanden, kleiner, gleich, groesser);

  PROCEDURE SucheStichwort (VAR such: STRING;
                            CONST derString: einPufferP);
  VAR  Index:    LONGINT;
       s:        STRING;
       i:        INTEGER;
       gefunden: einVergleich;
       ch:       CHAR;

  PROCEDURE NeuerIndex (VAR gefunden: einVergleich);
  VAR  AltIndex: LONGINT;

    FUNCTION RueckkorrigiereSeite (CONST Ind: LONGINT): LONGINT;
    BEGIN
      RueckkorrigiereSeite := Ind - ((Ind {+ IndexOffset + 4}) DIV Seite) *
        Seitenrest - 4;
    END (* KorrigiereSeite *);

    PROCEDURE KorrigiereSeite (VAR Ind: LONGINT);
    BEGIN
      Ind := Ind + ((Ind + IndexOffset - 1) DIV Seitennetto) *
        Seitenrest + 4;
    END (* KorrigiereSeite *);

  BEGIN (* NeuerIndex *)
    IF gefunden = kleiner THEN BEGIN
      ObereSchranke := Index;
    END
    ELSE IF gefunden = groesser THEN BEGIN
      UntereSchranke := Index;
    END;
    AltIndex := Index;
    Index := (((RueckkorrigiereSeite (ObereSchranke) +
               (RueckkorrigiereSeite (UntereSchranke))) DIV 2)
              DIV IndexOffset) * IndexOffset;
    KorrigiereSeite (Index);
    IF Index = AltIndex THEN gefunden := nichtvorhanden;
  END (* NeuerIndex *);

  BEGIN (* SucheStichwort *)
    ObereSchranke := LetzterDudenInd - DudenIndex;
    UntereSchranke := 0;
    gefunden := gleich;
    Index := (((ObereSchranke + UntereSchranke) DIV 2)
               DIV IndexOffset) * IndexOffset;
    Index := Index + ((Index + IndexOffset - 1) DIV Seitennetto) *
      Seitenrest + 4;

    GotoXY (1, 1); ClrEol;
    Write (StringvonLong (Index), ', ');
    Write ('Suchwort: '); ReadLn (such);
    FOR i := 1 TO LENGTH (such) DO
      such [i] := ASCIIFil (Cap (TRUE, such [i]));

    AltX := CursX; AltY := CursY; CursX := 0; CursY := 0;
    AltOff := Start + Offset;
    NeuOff := DudenIndex;
    SetOffs (Offset, Start, DudenIndex + Index);
    Modus := Mixed;
{
    Display (derString, Modus, AdrModus, Start, Offset, 1, 1);
}
    off := Index + DudenIndex - Start - 1;
    REPEAT
{
GotoXY (1, 1); ClrEol;
Write ('Start: ', StringVonLong (Start), ', Index: ', StringVonLong (Index),
', Offs: ', StringVonLong (Index + DudenIndex - Start),
       ', gesucht: ', such, '--> ');
FOR i := 0 TO 20 DO
  Write (ANSIFil (Char (derString^ [Index + DudenIndex - Start + i])));
ch := readKey; IF ch = escch THEN EXIT;
}
      i := 1; gefunden := gleich;
      WHILE (gefunden = gleich) AND (i <= LENGTH (such)) AND
            (Char (derString^ [off + i]) <> nulch)
        DO BEGIN
        IF (such [i] < Char (derString^[off + i])) THEN
          gefunden := kleiner
        ELSE IF (such [i] > Char (derString^[off + i])) THEN
          gefunden := groesser;
        {Write (such [i]);} INC (i);
      END (* WHILE *);

      IF (gefunden = gleich) THEN BEGIN
        IF i <= LENGTH (such) THEN gefunden := groesser
        ELSE IF (Char (derString^ [off + i]) <> nulch) THEN
          gefunden := kleiner;
      END (* ungleich lange Begriffe *);

      IF gefunden <> gleich THEN BEGIN
        {INC (Index, IndexOffset);}
{
GotoXY (1, 1); clrEol;
IF gefunden = groesser THEN Write (such, ' ist groesser')
ELSE Write (such, ' ist kleiner'); ch := ReadKey;
}
        NeuerIndex (gefunden);

        IF (Index + DudenIndex - Start + LENGTH (such) >= cPuffer) OR
           (Index + DudenIndex - Start < 0) THEN BEGIN
{GotoXY (1, 1); ClrEol; Write ('Puffer nachladen'); ch := ReadKey;}
          SetOffs (Offset, Start, DudenIndex + Index);
{
Display (derString, Modus, AdrModus, Start, Offset, 1, 1);
}
        END (* IF Puffer nachladen *);
        off := Index + DudenIndex - Start - 1;

(******************************************************************)
{IF Index MOD 10000 = 0 THEN BEGIN}
GotoXY (1, 1); ClrEol;
(*Write ('Index: ', StringVonLong (Index),
', Offs: ', StringVonLong (Index + DudenIndex - Start),
       ', gesucht: ', such, '--> ');
*)
i := 1;
WHILE (i <= 29) AND (derString^ [off + i] <> 0) DO BEGIN
  Write (ANSIFil (Char (derString^ [off + i])));
  INC (i);
END (* WHILE *);
(*ch := readKey; IF ch = escch THEN EXIT;*)
ClrEol;
{END;}
(******************************************************************)
      END (* IF NOT gefunden *);
      {IF (index MOD 10000 = 0) AND keypressed THEN BREAK;}
    UNTIL (gefunden = gleich) OR (gefunden = nichtvorhanden);
    IF gefunden = nichtvorhanden THEN BEGIN
      GotoXY (1, 1); ClrEol;
      Write ('Der Begriff: ', such, ' wurde nicht gefunden!');
      ReadLn;
    END (* nichtvorhanden *);
    Modus := ASCII;
    SetOffs (Offset, Start, DudenIndex + Index + ArtikelOffset);
    Jump (CursX, CursY);
  END (* SucheStichwort *);

BEGIN (* Blaettern *)
  grossMenu := FALSE;
  IF Modus = Mixed THEN CursModus := Hex
  ELSE CursModus := Modus;
  {CursX := CstartX; CursY := CstartY;}
  CursX := 0; CursY := 0;
  AltX := CursX; AltY := CursY; CursX := 0; CursY := 0;
  AltOff := Start + Offset;
  REPEAT
    IF grossMenu THEN BEGIN
      grossesMenue (Modus, AdrModus, Offset, CursX, CursY); (* grossMenu := FALSE; *)
    END (* IF *)
    ELSE BEGIN
      IF NOT (bef IN [nulch, tabch, belch]) OR (Modus = ASCII) THEN
        Display (Puffer, Modus, AdrModus, Start, Offset, CursX, CursY)
      ELSE KopfZeile (AdrModus, Start + Offset, CursX, CursY);
      CursorXY (CursX, CursY, CursModus);
    END (* ELSE *);
    bef := UpCase (ReadKey);
    CASE bef OF
      Escch: grossMenu := NOT grossMenu;

      Nulch: BEGIN
               key := ReadKey;
               CASE key OF
                 leftkey:   IF CursX > 0 THEN BEGIN
                              DEC (CursX);
                            END ELSE BEGIN
                              CursX := CEndX;
                              IF CursY > 0 THEN DEC (CursY) ELSE BEGIN
                                DecOffs (Offset, Start, Sprung);
                                Display (Puffer, Modus, AdrModus, Start, Offset, CursX, CursY);
                              END;
                            END;
                 rightkey:  IF CursX < CendX THEN BEGIN
                              INC (CursX);
                            END ELSE BEGIN
                              CursX := 0;
                              IF CursY < CendY THEN INC (CursY) ELSE BEGIN
                                IncOffs (Offset, Start, Sprung);
                                Display (Puffer, Modus, AdrModus, Start, Offset, CursX, CursY);
                              END;
                            END;
                 upkey:     IF CursY > 0 THEN DEC (CursY) ELSE BEGIN
                              DecOffs (Offset, Start, Sprung);
                              Display (Puffer, Modus, AdrModus, Start, Offset, CursX, CursY);
                            END;
                 downkey:   IF CursY < CendY THEN INC (CursY) ELSE BEGIN
                              IncOffs (Offset, Start, Sprung);
                              Display (Puffer, Modus, AdrModus, Start, Offset, CursX, CursY);
                            END;
                 pgupkey:   IF CursY = 0 THEN BEGIN
                              DecOffs (Offset, Start, Sprung * (endDisplay - startDisplay));
                              Display (Puffer, Modus, AdrModus, Start, Offset, CursX, CursY);
                            END
                            ELSE CursY := 0;
                 pgdownkey: IF CursY = CendY THEN BEGIN
                              IncOffs (Offset, Start, Sprung * (endDisplay - startDisplay));
                              Display (Puffer, Modus, AdrModus, Start, Offset, CursX, CursY);
                            END
                            ELSE CursY := CendY;
                 homekey:   CursX := 0;
                 endkey:    CursX := CendX;
                 ELSE BEGIN Write (belch); grossMenu := TRUE; END;
               END (* CASE *);
             END (* Nul *);

      tabch: IF Modus = Mixed THEN
               IF CursModus = Hex THEN CursModus := Mixed
             ELSE CursModus := Hex;
      '+':     BEGIN
                 KopfZeile (AdrModus, Start + Offset, CursX, CursY); WriteLn;
                 Write ('Sprung vorwrts: '); ClrEol;
                 IF AdrModus = LInt THEN ReadLn (NeuOff)
                 ELSE IF AdrModus = Hex THEN BEGIN
                   ReadLn (HexString);
                   NeuOff := NumVonHex (HexString);
                 END
                 ELSE NeuOff := 0;
                 AltX := CursX; AltY := CursY; CursX := 0; CursY := 0;
                 AltOff := Start + Offset;
                 IncOffs (Offset, Start, NeuOff);
               END;
      '-':     BEGIN
                 KopfZeile (AdrModus, Start + Offset, CursX, CursY); WriteLn;
                 Write ('Sprung rckwrts: '); ClrEol;
                 IF AdrModus = LInt THEN ReadLn (NeuOff)
                 ELSE IF AdrModus = Hex THEN BEGIN
                   ReadLn (HexString);
                   NeuOff := NumVonHex (HexString);
                 END
                 ELSE NeuOff := 0;
                 AltX := CursX; AltY := CursY; CursX := 0; CursY := 0;
                 AltOff := Start + Offset;
                 DecOffs (Offset, Start, NeuOff);
               END;
      '*':     BEGIN
                 NeuOff := Start + Offset + CursX + CursY * endSpalte;
                 AltX := CursX; AltY := CursY; CursX := 0; CursY := 0;
                 AltOff := Start + Offset;
                 SetOffs (Offset, Start, NeuOff);
               END;
      '1': BEGIN
             AltX := CursX; AltY := CursY; CursX := 0; CursY := 0;
             AltOff := Start + Offset;
             SetOffs (Offset, Start, Dateigroesse - cDisplay);
           END;
      '2': IncOffs (Offset, Start, Sprung);
      '3': IncOffs (Offset, Start, Sprung * (endDisplay - startDisplay));
      '4': DecOffs (Offset, Start, 1);
      {'5':}
      '6': IncOffs (Offset, Start, 1);
      '7': BEGIN
             AltX := CursX; AltY := CursY; CursX := 0; CursY := 0;
             AltOff := Start + Offset;
             SetOffs (Offset, Start, 0);
           END;
      '8': DecOffs (Offset, Start, Sprung);
      '9': DecOffs (Offset, Start, Sprung * (endDisplay - startDisplay));

      '#': BEGIN
             macheIndex;
           END;
      '>':     Speichern (Puffer, Modus, AdrModus, Offset, CursX, CursY);

      'A':     BEGIN Modus := ASCII; CursModus := ASCII; END;
      'B':     BEGIN
                 AltX := CursX; AltY := CursY;
                 AltOff := Start + Offset;
                 IF NOT Suchen (such, ANSIFiltern, Hex, CursX, CursY) THEN BEGIN
                   NeuOff := AltOff;
                   AltOff := Start + Offset;
                   SetOffs (Offset, Start, NeuOff);
                   CursX := AltX; CursY := AltY;
                 END;
               END;
      'C':     nurWoerter := NOT (nurWoerter);
      'D':     Drucken (Puffer, Modus, AdrModus, Offset, CursX, CursY);
      'E':     BEGIN
                 AltX := CursX; AltY := CursY;
                 AltOff := Start + Offset;
               END;
      'F':     ANSIFiltern:= NOT ANSIFiltern;
      'G':     grosskleinEgal := NOT grosskleinEgal;
      'H':     BEGIN Modus := Hex; CursModus := Hex; END;
      'I':     AdrModus := LInt;
      'J':     BEGIN
                 Jump (CursX, CursY);
               END;
      'K':     BEGIN
                 NeuOff := LiesKurzwort (Start + Offset + CursX + CursY * endSpalte, Relativ);
                 AltX := CursX; AltY := CursY; CursX := 0; CursY := 0;
                 AltOff := Start + Offset;
                 SetOffs (Offset, Start, NeuOff);
               END;
      'L':     BEGIN
                 NeuOff := LiesLangwort (Start + Offset + CursX + CursY * endSpalte, Relativ);
                 AltX := CursX; AltY := CursY; CursX := 0; CursY := 0;
                 AltOff := Start + Offset;
                 SetOffs (Offset, Start, NeuOff);
               END;
      'M':     BEGIN Modus := Mixed; CursModus := Hex; END;
      {}
      'N':     BEGIN
                 DateiName := '';
                 DateiOeffnen (Datei, Dateiname, Dateigroesse, Puffer);
               END;
      {}
      'O':     BEGIN
                 KopfZeile (AdrModus, Start + Offset, CursX, CursY); WriteLn;
                 Write ('Offset: '); ClrEol;
                 IF AdrModus = LInt THEN ReadLn (NeuOff)
                 ELSE IF AdrModus = Hex THEN BEGIN
                   ReadLn (HexString);
                   NeuOff := NumVonHex (HexString);
                 END
                 ELSE NeuOff := 0;
                 AltX := CursX; AltY := CursY; CursX := 0; CursY := 0;
                 AltOff := Start + Offset;
                 SetOffs (Offset, Start, NeuOff);
               END;
      'P':     BEGIN
                 NeuOff := BackLangwort (Start + Offset + CursX + CursY * endSpalte, Relativ);
                 AltX := CursX; AltY := CursY; CursX := 0; CursY := 0;
                 AltOff := Start + Offset;
                 SetOffs (Offset, Start, NeuOff);
               END;
      'Q':     BEGIN
                 ClrScr; Write ('Programm verlassen (J/N): ');
                 bef := UpCase (ReadKey);
                 IF bef = 'J' THEN bef := 'Q';
               END;
      'R':     Relativ := NOT Relativ;
      'S':     BEGIN
                 AltX := CursX; AltY := CursY;
                 AltOff := Start + Offset;
                 IF NOT Suchen (such, ANSIFiltern, ASCII, CursX, CursY) THEN BEGIN
                   NeuOff := AltOff;
                   AltOff := Start + Offset;
                   SetOffs (Offset, Start, NeuOff);
                   CursX := AltX; CursY := AltY;
                 END;
               END;
      'T':     Tabexpand := NOT Tabexpand;
      'U':     BEGIN
                 NeuOff := BackKurzwort (Start + Offset + CursX + CursY * endSpalte, Relativ);
                 AltX := CursX; AltY := CursY; CursX := 0; CursY := 0;
                 AltOff := Start + Offset;
                 SetOffs (Offset, Start, NeuOff);
               END;
      'V':     IndexEinstellen;
      'W':     AdrModus := Hex;
      'X':     Steuerzeichen := NOT Steuerzeichen;
      'Y':     BEGIN
                 Suchwort := ''; SucheStichwort (Suchwort, Puffer);
               END;
      'Z':     BEGIN
                 NeuOff := AltOff;
                 AltOff := Start + Offset;
                 SetOffs (Offset, Start, NeuOff);
                 CursX := AltX; CursY := AltY;
               END;
      ELSE Write (belch); {grossMenu := TRUE;}
    END (* CASE *);
  UNTIL (bef = 'Q');
END (* Blaettern *);

CONST x: INTEGER = 0; y: INTEGER = 0;
BEGIN
  NEW (Puffer);
  Tabweite := 8; ANSIFiltern := {FALSE} TRUE; TOOLBOOK := TRUE;
  Tabexpand := TRUE; Modus := Mixed {ASCII}; AdrModus := Hex;
  Relativ := FALSE;   grosskleinEgal := TRUE; nurWoerter := FALSE;
  such := ''; cmdarg := FALSE; Steuerzeichen := FALSE;
  PufferLoeschen (Puffer);
  Dateiname := ''; Dateigroesse := 0;
  Offset := 0; Start := 0;
  IF (ParamCount > 0) THEN BEGIN
    DateiName := ParamStr (1);
  END;
  DateiOeffnen (Datei, DateiName, Dateigroesse, Puffer);
  IF ParamCount > 1 THEN BEGIN
    eingabe := ParamStr (2);
    NeuOff := NumVonHex (eingabe);
    SetOffs (Offset, Start, NeuOff);
  END (* IF Offset als Commandline-Argument *)
  ELSE BEGIN {
    SetOffs (Offset, Start, $14);
    Jump (x, y);
    }
  END;
  IF DateiName <> '' THEN Blaettern (Modus, AdrModus);
  Close (Datei);
END (* Inspektor *).