UNIT SuperBase;

(* (C) 1993, 1994 by Johannes Leckebusch.
   Das Programm ist Shareware. Es darf in unvernderter und
   vollstndiger Form - einschlielich der DOC-Files - weitergegeben
   werden. Bei regelmiger Benutzung bitte ich um
   bersendung von DM 30,-
   mit dem Hinweis "Superfilter TP" an untenstehende Adresse:
   Johannes Leckebusch
   Schlierseerstr. 27
   83735 Bayrischzell
   Konto bei Kreissparkasse Miesbach, BLZ 711 517 50

   Ich bin auch zu erreichen ber die Maus, @MB.
   Die Tel. Nr. der Maus MB (Bayrischzell) ist 080 23/332.
   In der Maus MB sind auch Updates und Fehlerkorrekturen erhltlich.
   Wer das Programm verbessert oder erweitert, wird gebeten, mir
   die vernderte Version zu schicken. Bitte keine vernderten
   Versionen eigenmchtig in Umlauf bringen. *)

INTERFACE

CONST
	(* ASCII-Codes *)
	nulch =		#0; (* -> Extended Key *)
        belch =         #7;
	bsch =		#8; (* ctrl-bs liefert DEL = #127 *)
        ctrlbs =        #127;
	tabch =		#9;
        Tabpfeil =      #26;
        lfch =          #10;
        ffch =          #12;
	crch =		#13;
	linedel =	#25; (* ^Y *)
        lineundel =     #21; (* ^U *)
	escch =		#27;

      (* Extended Keys: *)

  (* Die Bezeichnungen folgen den Angaben im Anhang A2 des QuickPascal-
     Handbuches, jedoch wird (bei den Pfeiltasten) jeweils "key" angehngt *)

  (* Arrow *)

        ctrlins =       #4;
        shiftins =      #5;
        ctrldel =       #6;
        shiftdel =      #7;

	upkey =		#72;
	downkey =	#80;
	leftkey =	#75;
	rightkey =	#77;
	pgupkey =	#73;
	pgdownkey =	#81;
	homekey =	#71;
	endkey =	#79;
	inskey =	#82;
	delkey =	#83;

  (* CTRL + Arrow *)

	ctrlprtsc =	#114;
	ctrlleft =	#115;
	ctrlright =	#116;
	ctrlend =	#117;
	ctrlpgdn =	#118;
	ctrlhome =	#119;

	ctrlpgup =	#132;

	nullkey =	#3;
	shifttab =	#15;

  (* CONTROL + Letter *)

        ctrlb =         #02;

  (* ALT + Letter *)

	alta =		#30;
	altb =		#48;
	altc =		#46;
	altd =		#32;
	alte =		#18;
	altf =		#33;
	altg =		#34;
	alth =		#35;
	alti =		#23;
	altj =		#36;
	altk =		#37;
	altl =		#38;
	altm =		#50;
	altn =		#49;
	alto =		#24;
	altp =		#25;
	altq =		#16;
	altr =		#19;
	alts =		#31;
	altt =		#20;
	altu =		#22;
	altv =		#47;
	altw =		#17;
	altx =		#45;
	alty =		#21;
	altz =		#44;

  (* ALT + Number *)

	alt1 =		#120;
	alt2 =		#121;
	alt3 =		#122;
	alt4 =		#123;
	alt5 =		#124;
	alt6 =		#125;
	alt7 =		#126;
	alt8 =		#127;
	alt9 =		#128;
	alt0 =		#129;
	altminus =	#130;
	altgleich =	#131;

  (* Function *)

	f1 =		#59;
	f2 =		#60;
	f3 =		#61;
	f4 =		#62;
	f5 =		#63;
	f6 =		#64;
	f7 =		#65;
	f8 =		#66;
	f9 =		#67;
	f10 =		#68;

	f11 =		#133;
	f12 =		#134;

  (* SHIFT + Function *)

	shiftf1 =	#84;
	shiftf2 =	#85;
	shiftf3 =	#86;
	shiftf4 =	#87;
	shiftf5 =	#88;
	shiftf6 =	#89;
	shiftf7 =	#90;
	shiftf8 =	#91;
	shiftf9 =	#92;
	shiftf10 =	#93;

	shiftf11 =	#135;
	shiftf12 =	#136;

  (* CTRL + Function *)

	ctrlf1 =	#94;
	ctrlf2 =	#95;
	ctrlf3 =	#96;
	ctrlf4 =	#97;
	ctrlf5 =	#98;
	ctrlf6 =	#99;
	ctrlf7 =	#100;
	ctrlf8 =	#101;
	ctrlf9 =	#102;
	ctrlf10 =	#103;

	ctrlf11 = 	#137;
	ctrlf12 =	#138;

  (* ALT + Function *)

	altf1 =		#104;
	altf2 =		#105;
	altf3 =		#106;
	altf4 =		#107;
	altf5 =		#108;
	altf6 =		#109;
	altf7 =		#110;
	altf8 =		#111;
	altf9 =		#112;
	altf10 =	#113;

	altf11 =	#139;
	altf12 =	#140;

TYPE

        ZeichenSatz =   (* Beschreibt den erweiterten Zeichensatz
                           des IBM-PC und Atari, sofern unterschied-
                           liche Zeichen vorkommen, wurden die Namen
                           nach dem Aussehen auf dem Atari gewaehlt -
                           sorry, letzteres ist historisch bedingt! *)

          (* Steuerzeichen 0..31              Dezimal  Hex *)
        (
          NUL,  (* Null                      ^@   000   00 *)
          SOH,  (* start of heading?         ^A   001   01 *)
          STX,  (* start of text             ^B   002   02 *)
          ETX,  (* end of text               ^C   003   03 *)
          EOT,  (* end of transmission       ^D   004   04 *)
          ENQ,  (* enquiry                   ^E   005   05 *)
          ACK,  (* acknowledge               ^F   006   06 *)
          BEL,  (* bell                      ^G   007   07 *)
          BS,   (* back space                ^H   008   08 *)
          HT,   (* horizontal tabulation     ^I   009   09 *)
          LF,   (* line feed                 ^J   010   0A *)
          VT,   (* vertical tabulation       ^K   011   0B *)
          FF,   (* form feed                 ^L   012   0C *)
          CR,   (* carriage return           ^M   013   0D *)
          SO,   (* shift out                 ^N   014   0E *)
          SI,   (* shift in                  ^O   015   0F *)

          DLE,  (* data link escape          ^P   016   10 *)
          DC1,  (* device control 1          ^Q   017   11 *)
          DC2,  (* device control 2          ^R   018   12 *)
          DC3,  (* device control 3          ^S   019   13 *)
          DC4,  (* device control 4          ^T   020   14 *)
          NAK,  (*  negative acknowledge    ^U   021   15 *)
          SYN,  (* synchronous idle          ^V   022   16 *)
          ETB,  (* end of transmission block ^W   023   17 *)
          CAN,  (* cancel                    ^X   024   18 *)
          EM,   (* end of medium             ^Y   025   19 *)
          SUB,  (* start of special sequence ^Z   026   1A *)
          ESC,  (* escape                    ^[   027   1B *)
          FS,   (* file separator            ^\   028   1C *)
          GS,   (* group separator           ^]   029   1D *)
          RS,   (* record separator          ^^   030   1E *)
          US,   (* unit seperator            ^_   031   1F *)

          (* Normale druckbare US-ASCII-Zeichen            *)

          SP,           (* Leerzeichen            032   20 *)
          RufZ,         (* !                      033   21 *)
          AnfD,         (* ", Dopp. Anf.          034   22 *)
          Numm,         (* # Doppelkreuz          035   23 *)
          Doll,         (* $                      036   24 *)
          Proz,         (* %                      037   25 *)
          Und,          (* &                      038   26 *)
          AnfE,         (* ', Einf. Anf           039   27 *)
          RuAuf,        (* (                      040   28 *)
          RuZu,         (* )                      041   29 *)
          Stern,        (* *                      042   2A *)
          Plus,         (* +                      043   2B *)
          Komma,        (* ,                      044   2C *)
          Minus,        (* -                      045   2D *)
          Punkt,        (* .                      046   2E *)
          Schraeg,      (* /                      047   2F *)

          (* Ziffern *)

          Null,         (* 0                      048   30 *)
          Eins,         (* 1                      049   31 *)
          Zwei,         (* 2                      050   32 *)
          Drei,         (* 3                      051   33 *)
          Vier,         (* 4                      052   34 *)
          Fuenf,        (* 5                      053   35 *)
          Sechs,        (* 6                      054   36 *)
          Sieben,       (* 7                      055   37 *)
          Acht,         (* 8                      056   38 *)
          Neun,         (* 9                      057   39 *)

          (* Untere Sonderzeichen 1 *)

          DpP,          (* :                      058   3A *)
          Semik,        (* ;                      059   3B *)
          klein,        (* <                      060   3C *)
          glch,         (* =                      061   3D *)
          grsser,       (* >                      062   3E *)
          FrageZ,       (* ?                      063   3F *)
          AtSig,        (* @, Klammeraffe         064   40 *)

          (* Grossbuchstaben *)

          A,            (*                        065   41 *)
          B,            (*                        066   42 *)
          C,            (*                        067   43 *)
          D,            (*                        068   44 *)
          E,            (*                        069   45 *)
          F,            (*                        070   46 *)
          G,            (*                        071   47 *)
          H,            (*                        072   48 *)
          I,            (*                        073   49 *)
          J,            (*                        074   4A *)
          K,            (*                        075   4B *)
          L,            (*                        076   4C *)
          M,            (*                        077   4D *)
          N,            (*                        078   4E *)
          O,            (*                        079   4F *)
          P,            (*                        080   50 *)
          Q,            (*                        081   51 *)
          R,            (*                        082   52 *)
          S,            (*                        083   53 *)
          T,            (*                        084   54 *)
          U,            (*                        085   55 *)
          V,            (*                        086   56 *)
          W,            (*                        087   57 *)
          X,            (*                        088   58 *)
          Y,            (*                        089   59 *)
          Z,            (*                        090   5A *)

          (* Untere Sonderzeichen 2 *)
                        (* (deutsche Umlaute ASCII) *)

          EckAuf,       (* [ (grosses Ae)         091   5B *)
          RueckStr,     (* \ (grosses Oe)         092   5C *)
          EckZu,        (* ] grosses Ue           093   5D *)
          Power,        (* ^                      094   5E *)
          Unterstr,     (* _                      095   5F *)

          (* Kleinbuchstaben *)

          Akz1,         (* `                      096   60 *)
          ka,           (*                        097   61 *)
          kb,           (*                        098   62 *)
          kc,           (*                        099   63 *)
          kd,           (*                        100   64 *)
          ke,           (*                        101   65 *)
          kf,           (*                        102   66 *)
          kg,           (*                        103   67 *)
          kh,           (*                        104   68 *)
          ki,           (*                        105   69 *)
          kj,           (*                        106   6A *)
          kk,           (*                        107   6B *)
          kl,           (*                        108   6C *)
          km,           (*                        109   6D *)
          kn,           (*                        110   6E *)
          ko,           (*                        111   6F *)
          kp,           (*                        112   70 *)
          kq,           (*                        113   71 *)
          kr,           (*                        114   72 *)
          ks,           (*                        115   73 *)
          kt,           (*                        116   74 *)
          ku,           (*                        117   75 *)
          kv,           (*                        118   76 *)
          kw,           (*                        119   77 *)
          kx,           (*                        120   78 *)
          ky,           (*                        121   79 *)
          kz,           (*                        122   7A *)

          (* Untere Sonderzeichen 3 *)
                        (* (deutsche Umlaute ASCII) *)

          SchwfAuf,     (* { (kleines ae)         123   7B *)
          SenkrStrich,  (* | (kleines oe)         124   7C *)
          SchwfZu,      (* } (kleines ue)         125   7D *)
          Tilde,        (* ~ (scharfes sz)        126   7E *)
          DEL,          (* delete, auch Delta     127   7F *)

          (* Erweiterter ASCII-Code 128-255, internationale Zeichen *)

          Cedill,       (* C, franzoesisch        128   80 *)
          kupp,         (* u.. Umlaut             129   81 *)
          keAigu,       (* e'                     130   82 *)
          kaCirc,       (* a^                     131   83 *)
          kapp,         (* a.. Umlaut             132   84 *)
          kaGrav,       (* a`                     133   85 *)
          kao,          (* o ueber a              134   86 *)
          kcedill,      (* c, franzoesisch        135   87 *)
          keCirc,       (* e^                     136   88 *)
          kepp,         (* e..                    137   89 *)
          keGrav,       (* e`                     138   8A *)
          kipp,         (* i..                    139   8B *)
          kiCirc,       (* i^                     140   8C *)
          kiGrav,       (* i`                     141   8D *)
          App,          (* A.. Umlaut             142   8E *)
          Ao,           (* o ueber A              143   8F *)

          EAig,         (* E'                     144   90 *)
          kae,          (* ae Ligatur,            145   91 *)
          AE,           (* AE Ligatur,            146   92 *)
          oCirc,        (* o^                     147   93 *)
          kopp,         (* o.. Umlaut             148   94 *)
          koGrav,       (* o`                     149   95 *)
          kuCirc,       (* u^                     150   96 *)
          kuGrav,       (* u`                     151   97 *)
          kypp,         (* y..                    152   98 *)
          Opp,          (* O.. Umlaut             153   99 *)
          Upp,          (* U.. Umlaut             154   9A *)
          cent,         (* c/, Cent-Zeichen       155   9B *)
          pound,        (* #, britisch Pfund      156   9C *)
          Yen,          (* y_, japanischer Yen    157   9D *)
          Pts,          (* spanische Peseta/sz    158   9E *)
          Guld,         (* f, holl. Gulden        159   9F *)

          kaAigu,       (* a'                     160   A0 *)
          kiAigu,       (* i'                     161   A1 *)
          koAigu,       (* o'                     162   A2 *)
          kuAigu,       (* u'                     163   A3 *)
          knTild,       (* spanisch n~            164   A4 *)
          NTild,        (* spanisch N~            165   A5 *)
          FemOrd,       (* a_, feminin. Ordinal   166   A6 *)
          MaskOrd,      (* o_, maskul. Ordinal    167   A7 *)
          spanFrag,     (* ? verkehrt, spanisch   168   A8 *)
          NegBack,      (* Negation verkehrt      169   A9 *)
          Neg,          (*                        170   AA *)
          halb,         (* 1/2                    171   AB *)
          viert,        (* 1/4                    172   AC *)
          spanRuf,      (* ! verkehrt, spanisch   173   AD *)
          Abf,          (* <<                     174   AE *)
          Anf,          (* >>                     175   AF *)

          kaTild,       (* a~                     176   B0 *)
          koTild,       (* o~                     177   B1 *)
          OSchraeg,     (* O/                     178   B2 *)
          koSchraeg,    (* o/                     179   B3 *)
          koe,          (* oe Ligatur,            180   B4 *)
          OE,           (* OE Ligatur,            181   B5 *)
          AGrav,        (* A`                     182   B6 *)
          ATild,        (* A~                     183   B7 *)
          OTild,        (* O~                     184   B8 *)
          pp,           (* .., Trema (hochgest)   185   B9 *)
          Aigu,         (* '                      186   BA *)
          Kreuz,        (* + hochgestellt         187   BB *)
          Abs,          (* P_ spiegelverkehrt     188   BC *)
          CopyR,        (* (C)                    189   BD *)
          Reg,          (* (R)                    190   BE *)
          TM,           (* TradeMark              191   BF *)

          kij,          (* ij Doppelzeichen       192   C0 *)
          IJ,           (* IJ Doppelzeichen       193   C1 *)

     (* hebraeische Zeichen: *)

          Aleph,        (*                        194   C2 *)
          Beta,         (*                        195   C3 *)
          Gimel,        (*                        196   C4 *)
          Dalet,        (*                        197   C5 *)
          He,           (*                        198   C6 *)
          Waw,          (*                        199   C7 *)
          Zajin,        (*                        200   C8 *)
          Het,          (*                        201   C9 *)
          Tet,          (*                        202   CA *)
          Jod,          (*                        203   CB *)
          Kaf,          (*                        204   CC *)
          Lamed,        (*                        205   CD *)
          Mem,          (*                        206   CE *)
          Nun,          (*                        207   CF *)

          Samech,       (*                        208   D0 *)
          Ajin,         (*                        209   D1 *)
          Pe,           (*                        210   D2 *)
          Sade,         (*                        211   D3 *)
          Qof,          (*                        212   D4 *)
          Resch,        (*                        213   D5 *)
          Sin,          (*                        214   D6 *)
          Taw,          (*                        215   D7 *)
          Z216,         (*                        216   D8 *)
          KafWEnde,     (* Kaf am Wortende        217   D9 *)
          MemWEnde,     (* Mem am Wortende        218   DA *)
          PeWEnde,      (* Pe am Wortende         219   DB *)
          SadeWEnde,    (* Sade am Wortende       220   DC *)

          (* verschiedene weitere Sonderzeichen, u. a. griechisch *)

          Paragr,       (* @                      221   DD *)
          Lambda,       (*                        222   DE *)
          Unend,        (*                        223   DF *)

          alpha,        (*                        224   E0 *)
          sz,           (* deutsches sz, beta     225   E1 *)
          Gamma,        (*                        226   E2 *)
          pi,           (*                        227   E3 *)
          Sigma,        (*                        228   E4 *)
          ksigma,       (*                        229   E5 *)
          my,           (*                        230   E6 *)
          tau,          (*                        231   E7 *)
          Phi,          (*                        232   E8 *)
          Theta,        (*                        233   E9 *)
          Omega,        (*                        234   EA *)
          delta,        (*                        235   EB *)
          Z236,         (*                        236   EC *)
          Z237,         (*                        237   ED *)
          Epsilon,      (* griech.,
                          auch Element d. Menge   238   EE *)
          DSchn,        (* Mengendurchschnitt     239   EF *)

          ident,        (* = m. drei Balken       240   F0 *)
          PM,           (* +-                     241   F1 *)
          GrGlch,       (* >=                     242   F2 *)
          KlGlch,       (* <=                     243   F3 *)
          IntOb,        (* Integral ob. Haelf.    244   F4 *)
          IntUnt,       (* Integral un. Haelf.    245   F5 *)
          DivZ,         (* :- Div.-Zeichen.       246   F6 *)
          Prop,         (* ~~, Proprotional       247   F7 *)
          Grad,         (*                        248   F8 *)
          Z249,         (*                        249   F9 *)
          Mult,         (* . Malpunkt             250   FA *)
          Wurzel,       (* Wurzelzeichen          251   FB *)
          Hn,           (* wie n hoch, Verkett.   252   FC *)
          H2,           (* 2 hochgestellt         253   FD *)
          H3,           (* 3 hochgestellt         254   FE *)
          Ueberstr      (* _ oben                 255   FF *)
          );

        TextFormat =    (
          ASCII256,     (* internationaler Zeichensatz *)
          FIRSTWORD,    (* GST First Word *)
          USASCII128,   (* normale ASCII-Datei wie Non-Dokument,
                           128-Zeichen-Code,
                           Programmeditoren (Turbo) USA *)
          GERASCII128,  (* normale ASCII-Datei 128 Zeichen,
                           aber Deutsch *)
          SMTEXT,       (* SM-Textverarbeitung auf Atari *)
          WS30DOC,      (* WordStar DOC-File USASCII, 128 *)
          WS30GER,      (* WordStar DOC-File Deutsch, 128 *)
          WS30SPA,      (* WordStar DOC-File Spanisch, 128 *)
          WS34MSDOS,    (* WordStar 3.4, mit markierten Sonderzeichen
                           durch Steuerzeichen, international *)
          MSWORD,       (* Microsoft Word *)
          UCSD,         (* UCSD-Textformat *)
          SIMPEL,       (* SIMPEL Golem Editor *)
          G2E,          (* Grafik-G2E *)
          ANSI,         (* Windows-Zeichensatz *)
          ANSIEndlos,   (* ANSI mit endlosen Abstzen *)
          TOOLBOOK      (* Format von ToolBook-Wrterbchern *)
          );         

        Formate =       SET OF TextFormat;

     (* Der folgende Aufzaehlungstyp wurde so angeordnet, dass die
        die Ordinalzahlen der Werte mit der Binaercodierung der
        Textattribute von 1ST-Word uebereinstimmen. Das ermoeglicht
        die "magische" Behandlung der Textattribute von 1ST-Word. *)

        Attribute =     (fett, hell, kursiv, unterstrichen,
                         hochgestellt, tiefgestellt, doppel);

        Attribut =       SET OF Attribute;

     (* Der folgende Aufzaehlungstyp ist analog fuer die Erzeugung
        von SM-Text-Attributen gestaltet: *)

        SMAttribute =   (SMunterstrichen, SMfett,
                         SMinvertiert);

        SMAttribut =    SET OF SMAttribute;

        DateiName =     ARRAY [0..20] OF CHAR;

        WordInfo =      RECORD
                          Magik1:       WORD;
                          Magik2:       WORD;
                          Magik3:       WORD;
                          dumm1:        ARRAY [0..7] OF CHAR;
                          Anzahl0:      WORD; (* Lower Word *)
                          Anzahl1:      WORD; (* Higher Word *)
                          dumm2:        ARRAY [0..109] OF CHAR;
                        END (* WordInfo *);

        UCSDInfo =      RECORD
                          dumm:         ARRAY [0..1023] OF CHAR;
                        END (* UCSDInfo *);
        eineInfo =      {ARRAY [0..59] OF CHAR} STRING [60]; (* Pfadname *)

CONST   WSRETURN =              kiGrav; (* WS weiches RETURN *)
        WSVorMark =             ESC;    (* WS 3.4 Umlautmarkierung *)
        WSEndMark =             FS;     (* WS 3.4 Umlautmarkierung *)
        WSVorMarkHigh =         cent;   (* WS 3.4 Umlautm. statt 8. Bit *)
        WSSpace =               kaAigu; (* markiertes Leerzeichen WS *)
        WSTrenn1 =              RS;     (* markiertes - Trennhilfe *)
        WSTrenn2 =              US;     (* Trennung a. Zeilenende *)

        WordTrenn =             US;      (* Word Trennhilfe *)

        UCSDBlank =             DLE;    (* UCSD Blank Kompressionscode *)

        FWVarSpace =            RS;     (* 1ST-Word variabler Leerraum *)
        FWIndent =              GS;     (* 1ST-Word variable Einrueck. *)
        FWStretch =             FS;     (* 1ST-Word Leerraum-Dehnung *)
        FWForm =                US;     (* Leitet Format-Zeile ein *)
        FWTrenn =               EM;     (* Phantom-Trennzeichen *)

        (* ANSI-Zeichen (Windows) *)

        AnsiSpanRuf =           #161;
        AnsiCent =              #162;
        AnsiPfund =             #163;
        Ansi164 =               #164;
        AnsiYen =               #165;
        AnsiBar =               #166;
        AnsiPara =              #167;
        AnsiPP =                #168;
        AnsiCopyR =             #169;
        Ansikaunter =           #170;
        AnsiFranzabf =          #171;
        AnsiNegation =          #172;
        Ansi173 =               #173;
        AnsiReg =               #174;
        Ansi175 =               #175;
        AnsiGrad =              #176;
        AnsiPM =                #177;
        AnsiHoch2 =             #178;
        AnsiHoch3 =             #179;
        AnsiAigu =              #180;
        AnsiMue =               #181;
        AnsiParagraph =         #182;

        AnsiHoch1 =             #185;

        AnsiEinviertel =        #188;
        AnsiEinhalb =           #189;
        AnsiDreiviertel =       #190;

        AnsiSpanFrag =          #191;
        AnsiAgrave =            #192;
        AnsiAaigu =             #193;
        AnsiAdach =             #194;
        AnsiAtild =             #195;
        AnsiApp =               #196;
        AnsiAo =                #197;
        AnsiAe =                #198;
        AnsiCedill =            #199;
        AnsiEgrave =            #200;
        AnsiEaigu =             #201;
        AnsiEdach =             #202;
        AnsiEpp =               #203;
        AnsiIgrave =            #204;
        AnsiIaigu =             #205;
        AnsiIdach =             #206;
        AnsiIpp =               #207;
        AnsiDstrich =           #208;
        AnsiNTild =             #209;
        AnsiOgrave =            #210;
        AnsiOaigu =             #211;
        AnsiOdach =             #212;
        AnsiOtild =             #213;
        AnsiOpp =               #214;
        AnsiOslash =            #216;
        AnsoUgrave =            #217;
        AnsiUaigu =             #218;
        AnsiUdach =             #219;
        AnsiUpp =               #220;
        AnsiYaigu =             #221;
        Ansi222 =               #222;
        AnsiSZ =                #223;
        Ansikagrave =           #224;
        Ansikaaigu =            #225;
        Ansikadach =            #226;
        Ansikatild =            #227;
        Ansikapp =              #228;
        Ansikao =               #229;
        Ansikae =               #230;
        Ansikcedill =           #231;
        AnsikeGrave =           #232;
        AnsikeAigu =            #233;
        AnsikeDach =            #234;
        Ansikepp =              #235;
        AnsikiGrave =           #236;
        AnsikiAigu =            #237;
        AnsikiDach =            #238;
        Ansikipp =              #239;
        Ansi240 =               #240;
        AnsiknTild =            #241;
        AnsikoGrave =           #242;
        AnsikoAigu =            #243;
        AnsikoDach =            #244;
        AnsikoTild =            #245;
        Ansikopp =              #246;

        AnsikuGrave =           #249;
        AnsikuAigu =            #250;
        AnsikuDach =            #251;
        Ansikupp =              #252;
        AnsikyAigu =            #253;
        Ansi254 =               #254;
        Ansikypp =              #255;

VAR
        ANSIFiltern:            BOOLEAN;

FUNCTION ASCIIFil (Zeichen: CHAR): CHAR;
FUNCTION ANSIFil (Zeichen: CHAR): CHAR;
PROCEDURE WriteFormat (f: TextFormat);
PROCEDURE INCL (VAR AttrSet: Attribut; Attr: Attribute);
PROCEDURE EXCL (VAR AttrSet: Attribut; Attr: Attribute);
PROCEDURE SymmDiff (VAR Diff: Attribut; At1, At2: Attribut);


IMPLEMENTATION

(*
                            Shareware DM 30,-

   Begonnen: 14. 12. 85
   Stand:    13. 09. 94
   Portierung Turbo Pascal: Januar 1993

             <<<---------- Der Superfilter ---------->>>

*)

PROCEDURE SymmDiff (VAR Diff: Attribut; At1, At2: Attribut);
BEGIN
  Diff := (At1 + At2) - At1 * At2;
END (* SymmDiff *);

FUNCTION ASCIIFil (Zeichen: CHAR): CHAR;
BEGIN
  CASE ZeichenSatz (Zeichen) OF
    App:        Zeichen := AnsiApp;
    Opp:        Zeichen := AnsiOpp;
    Upp:        Zeichen := AnsiUpp;
    kapp:       Zeichen := Ansikapp;
    kopp:       Zeichen := Ansikopp;
    kupp:       Zeichen := Ansikupp;
    sz{, Pts}:    Zeichen := AnsiSZ;
    spanRuf:    Zeichen := AnsiSpanRuf;
    cent:       Zeichen := AnsiCent;
    pound:      Zeichen := AnsiPfund;
    Yen:        Zeichen := AnsiYen;
    {SenkrStrich: Zeichen := AnsiBar;}
    NAK:        Zeichen := AnsiPara;
    my:         Zeichen := AnsiMue;
    SpanFrag:   Zeichen := AnsiSpanFrag;
    Cedill:     Zeichen := AnsiCedill;
    kcedill:    Zeichen := Ansikcedill;
    NTild:      Zeichen := AnsiNTild;
    knTild:     Zeichen := AnsiknTild;
    pp:         Zeichen := AnsiPP;
    CopyR:      Zeichen := AnsiCopyR;
    Reg:        Zeichen := AnsiReg;
    FemOrd:     Zeichen := Ansikaunter;
    Abf:        Zeichen := AnsiFranzabf;
    Neg:        Zeichen := AnsiNegation;
    (* Ansi173 *)
    NegBack:    Zeichen := AnsiReg; (* ??? *)
    (* Ansi175 *)
    Grad:       Zeichen := AnsiGrad;
    PM:         Zeichen := AnsiPM;
    H2:         Zeichen := AnsiHoch2;
    H3:         Zeichen := AnsiHoch3;
    AnfE:       Zeichen := AnsiAigu;
    Power:      Zeichen := AnsiParagraph; (* ??? *)
    {AnsiHoch1:    Zeichen := '1'; (* ??? *)}
    viert:      Zeichen := AnsiEinviertel;
    halb:       Zeichen := AnsiEinhalb;
    {AnsiDreiviertel: BEGIN
                  Write ('3/4');
                    END;}
    {AnsiAgrave:   Zeichen := 'A'; (* ??? *)
    AnsiAaigu:    Zeichen := 'A'; (* ??? *)
    AnsiAdach:    Zeichen := 'A';
    AnsiAtild:    Zeichen := 'A';
    }
    Ao:           Zeichen := AnsiAo;
    Ae:           Zeichen := AnsiAe;
    {AnsiEgrave:   Zeichen := 'E';}
    EAig:         Zeichen := AnsiEaigu;
    {
    AnsiEdach:    Zeichen := 'E';
    AnsiEpp:      Zeichen := 'E';
    AnsiIgrave:   Zeichen := 'I';
    AnsiIaigu:    Zeichen := 'I';
    AnsiIdach:    Zeichen := 'I';
    AnsiIpp:      Zeichen := 'I';
    AnsiDstrich:  Zeichen := 'D';
    AnsiOgrave:   Zeichen := 'O';
    AnsiOaigu:    Zeichen := 'O';
    }
    OCirc:        Zeichen := AnsiOdach;
    {AnseOtild:    Zeichen := 'O';}
    Z237:         Zeichen := AnsiOslash;
    {AnsoUgrave:   Zeichen := 'U';
    AnsiUaigu:    Zeichen := 'U';
    AnsiUdach:    Zeichen := 'U';
    }
    {
    AnsiYaigu:    Zeichen := 'Y';
    Ansi222:      Zeichen := 'p';
    }

    kagrav:       Zeichen := Ansikagrave;
    kaAigu:       Zeichen := Ansikaaigu;
    kaCirc:       Zeichen := Ansikadach;
    {Ansikatild:   Zeichen := 'a';}
    kao:          Zeichen := Ansikao;
    kae:          Zeichen := Ansikae;
    keGrav:       Zeichen := AnsikeGrave;
    keAigu:       Zeichen := AnsikeAigu;
    keCirc:       Zeichen := AnsikeDach;
    kepp:         Zeichen := Ansikepp;
    kiGrav:       Zeichen := AnsikiGrave;
    kiAigu:       Zeichen := AnsikiAigu;
    kiCirc:       Zeichen := AnsikiDach;
    kipp:         Zeichen := Ansikipp;
    {Ansi240:      Zeichen := 'o'; (* ??? *)}
    koGrav:       Zeichen := AnsikoGrave;
    koAigu:       Zeichen := AnsikoAigu;
    {AnsikoDach:   Zeichen := 'o';}
    koTild:       Zeichen := AnsikoTild;

    kuGrav:       Zeichen := AnsikuGrave;
    kuAigu:       Zeichen := AnsikuAigu;
    kuCirc:       Zeichen := AnsikuDach;
    {AnsikyAigu:   Zeichen := 'y';
    Ansi254:      Zeichen := 'p'; (* ??? *)
    }
    kypp:         Zeichen := Ansikypp;
    ELSE;
  END (* CASE *);
  ASCIIFil := Zeichen;
END (* ASCIIFil *);

FUNCTION ANSIFil (Zeichen: CHAR): CHAR;
BEGIN
  IF NOT ANSIFiltern THEN BEGIN ANSIFil := Zeichen; EXIT; END;
  CASE Zeichen OF
    {CHR (ORD (LF)): Zeichen := CHR (ORD (CR));}
    {
    CHR (ORD (US)):
         IF TOOLBOOK THEN BEGIN
           GetZeichen (Zeichen);
           CASE Zeichen OF
             CHR (ORD (LF)): BEGIN
                    Zeichen := CHR (ORD (CR));
                  END;
             'a': (* Kleines a, nach ^_, scheint Ende
                     des Stichwortes anzuzeigen ... *)
                  BEGIN
                    Zeichen := CHR (ORD (NUL));
                  END;
             'A': (* Groes A, nach ^_, scheint Anfang
                     des Stichwortes anzuzeigen ... *)
                  BEGIN
                    Zeichen := CHR (ORD (NUL));
                    PutZeichen (CHR (ORD (Z249)));
                    PutZeichen (' ');
                  END;
           END (* CASE *);
         END (* US *);
    }
    CHR (ORD (kaAigu)):
         BEGIN
           Zeichen := CHR (ORD (NUL));
         END;
    AnsiSpanRuf:  Zeichen := CHR (ORD (spanRuf));
    AnsiCent:     Zeichen := CHR (ORD (cent));
    AnsiPfund:    Zeichen := CHR (ORD (pound));
    AnsiYen:      Zeichen := CHR (ORD (Yen));
    AnsiBar:      Zeichen := CHR (ORD (SenkrStrich));
    AnsiPara:     Zeichen := CHR (ORD (NAK));
    AnsiPP:       Zeichen := CHR (ORD (pp));
    AnsiCopyR:    Zeichen := CHR (ORD (CopyR));
    Ansikaunter:  Zeichen := CHR (ORD (FemOrd));
    AnsiFranzabf: Zeichen := CHR (ORD (Abf));
    AnsiNegation: Zeichen := CHR (ORD (Neg));
    (* Ansi173 *)
    AnsiReg:      Zeichen := CHR (ORD (NegBack)); (* ??? *)
    (* Ansi175 *)
    AnsiGrad:     Zeichen := CHR (ORD (Grad));
    AnsiPM:       Zeichen := CHR (ORD (PM));
    AnsiHoch2:    Zeichen := CHR (ORD (H2));
    AnsiHoch3:    Zeichen := CHR (ORD (H3));
    AnsiAigu:     Zeichen := '''';
    AnsiMue:      Zeichen := CHR (ORD (my));
    AnsiParagraph: Zeichen := '^'; (* ??? *)
    AnsiHoch1:    Zeichen := '1'; (* ??? *)
    AnsiEinviertel: Zeichen := CHR (ORD (viert));
    AnsiEinhalb:  Zeichen := CHR (ORD (halb));
    AnsiDreiviertel: BEGIN
                  Write ('3/4');
                    END;
    AnsiSpanFrag: Zeichen := CHR (ORD (SpanFrag));
    {
    AnsiAgrave:   Zeichen := 'A'; (* ??? *)
    AnsiAaigu:    Zeichen := 'A'; (* ??? *)
    AnsiAdach:    Zeichen := 'A';
    AnsiAtild:    Zeichen := 'A';
    }
    AnsiApp:      Zeichen := CHR (ORD (App));
    AnsiAo:       Zeichen := CHR (ORD (Ao));
    AnsiAe:       Zeichen := CHR (ORD (Ae));
    AnsiCedill:   Zeichen := CHR (ORD (Cedill));
    AnsiEgrave:   Zeichen := 'E';
    AnsiEaigu:    Zeichen := CHR (ORD (EAig));
    AnsiEdach:    Zeichen := 'E';
    AnsiEpp:      Zeichen := 'E';
    AnsiIgrave:   Zeichen := 'I';
    AnsiIaigu:    Zeichen := 'I';
    AnsiIdach:    Zeichen := 'I';
    AnsiIpp:      Zeichen := 'I';
    AnsiDstrich:  Zeichen := 'D';
    AnsiNTild:    Zeichen := CHR (ORD (NTild));
    AnsiOgrave:   Zeichen := 'O';
    AnsiOaigu:    Zeichen := 'O';
    AnsiOdach:    Zeichen := CHR (ORD (OCirc));
    AnsiOtild:    Zeichen := 'O';
    AnsiOpp:      Zeichen := CHR (ORD (Opp));
    AnsiOslash:   Zeichen := CHR (ORD (Z237));
    AnsoUgrave:   Zeichen := 'U';
    AnsiUaigu:    Zeichen := 'U';
    AnsiUdach:    Zeichen := 'U';
    AnsiUpp:      Zeichen := CHR (ORD (Upp));
    AnsiYaigu:    Zeichen := 'Y';
    Ansi222:      Zeichen := 'p';

    AnsiSZ:       Zeichen := CHR (ORD (sz));

    Ansikagrave:  Zeichen := CHR (ORD (kagrav));
    Ansikaaigu:   Zeichen := CHR (ORD (kaAigu));
    Ansikadach:   Zeichen := CHR (ORD (kaCirc));
    Ansikatild:   Zeichen := 'a';
    Ansikapp:     Zeichen := CHR (ORD (kapp));
    Ansikao:      Zeichen := CHR (ORD (kao));
    Ansikae:      Zeichen := CHR (ORD (kae));
    Ansikcedill:  Zeichen := CHR (ORD (kcedill));
    AnsikeGrave:  Zeichen := CHR (ORD (keGrav));
    AnsikeAigu:   Zeichen := CHR (ORD (keAigu));
    AnsikeDach:   Zeichen := CHR (ORD (keCirc));
    Ansikepp:     Zeichen := CHR (ORD (kepp));
    AnsikiGrave:  Zeichen := CHR (ORD (kiGrav));
    AnsikiAigu:   Zeichen := CHR (ORD (kiAigu));
    AnsikiDach:   Zeichen := CHR (ORD (kiCirc));
    Ansikipp:     Zeichen := CHR (ORD (kipp));
    Ansi240:      Zeichen := 'o'; (* ??? *)
    AnsiknTild:   Zeichen := CHR (ORD (knTild));
    AnsikoGrave:  Zeichen := CHR (ORD (koGrav));
    AnsikoAigu:   Zeichen := CHR (ORD (koAigu));
    AnsikoDach:   Zeichen := 'o';
    AnsikoTild:   Zeichen := CHR (ORD (koTild));
    Ansikopp:     Zeichen := CHR (ORD (kopp));

    AnsikuGrave:  Zeichen := CHR (ORD (kuGrav));
    AnsikuAigu:   Zeichen := CHR (ORD (kuAigu));
    AnsikuDach:   Zeichen := CHR (ORD (kuCirc));
    Ansikupp:     Zeichen := CHR (ORD (kupp));
    AnsikyAigu:   Zeichen := 'y';
    Ansi254:      Zeichen := 'p'; (* ??? *)
    Ansikypp:     Zeichen := CHR (ORD (kypp));

    ELSE;
  END (* CASE Zeichen *);
  ANSIFil := Zeichen;
END (* ANSIFil *);

PROCEDURE WriteFormat (f: TextFormat);
BEGIN
  CASE f OF
    FIRSTWORD:          Write ('1ST WORD von GST');
    USASCII128:         Write ('USA-ASCII 128 Codes');
    GERASCII128:        Write ('Deutsch-ASCII 128 Codes');
    SMTEXT:             Write ('SM-Textsystem 128 Codes');
    ANSI:               Write ('ANSI');
    ANSIEndlos:         Write ('ANSI mit Endlosabstzen');
    TOOLBOOK:           Write ('TOOLBOOK');
    ASCII256:           Write ('ASCII 256 Codes');
    WS30DOC:            Write ('WS 3.0 USA 128 Codes');
    WS30GER:            Write ('WS 3.0 deutsch 128 Codes');
    WS30SPA:            Write ('WS 3.0 spanisch 128 Codes');
    WS34MSDOS:          Write ('WS 3.4 256 Codes');
    MSWORD:             Write ('Microsoft Word');
    UCSD:               Write ('UCSD-Textformat');
    SIMPEL:             Write ('SIMPEL (DOS-ASCII mit Umbruch)');
    G2E:                Write ('G2E Der Golden Two Editor (Atari)');
  END (* CASE *);
END (* WriteFormat *);

PROCEDURE INCL (VAR AttrSet: Attribut; Attr: Attribute);
BEGIN
  AttrSet := AttrSet + [Attr];
END;

PROCEDURE EXCL (VAR AttrSet: Attribut; Attr: Attribute);
BEGIN
  AttrSet := AttrSet - [Attr];
END;

BEGIN
  ANSIFiltern := FALSE;
END (* SuperBase *).
