PROGRAM SuperFilter;

(* (C) 1993 by Johannes Leckebusch.
   Das Programm ist Shareware. Es darf in unvernderter und
   vollstndiger Form - einschlielich der DOC-Files - weitergegeben
   werden. Bei regelmiger Benutzung bitte ich um
   bersendung von DM 30,-
   mit dem Hinweis "Superfilter TP/PP" an untenstehende Adresse:
   Johannes Leckebusch
   Schlierseerstr. 27
   83735 Bayrischzell
   Konto bei Kreissparkasse Miesbach, BLZ 711 517 50

   Ich bin auch zu erreichen ber die Maus, @MB.
   Die Tel. Nr. der Maus TLz ist 080 23/332.
   In der Maus TLz sind auch Updates und Fehlerkorrekturen erhltlich.
   Wer das Programm verbessert oder erweitert, wird gebeten, mir
   die vernderte Version zu schicken. Bitte keine vernderten
   Versionen eigenmchtig in Umlauf bringen.

   Noch was - vielleicht habt ihr noch nie solchen Code gesehen ...
   das Programm war nie als Beispiel fr guten Programmierstil gedacht.
   Auerdem ist es von Modula-2 portiert. Vergebt mir ...

*)

(*************** Alter (C) - Text der Originalversion in TDI-Modula:

   Idee und Realisation: Johannes Leckebusch Dezember '85/Januar '86

            Fuer alle Freaks und alle Anti-Freaks (USER)
                                   &
                 die Leser von Computer persoenlich

   Beratung: Guenter Juergensmeier, Herbert Thiess, Wolfgang Huber,
             Walter Kronester und viele andere.
             Dank auch an die Kollegen und Freunde,
             die das Programm getestet oder Anregungen gegeben haben!

     Weiterer Dank an:
   Version 1.1: Michael Spehr (Testfiles SM-Text mit Hervorhebungen)
             und Beseitigung div. Fehler bei SM-Format. Auf Vorschlag
             von H. Spehr wird SM-invers als ST-hochgestellt
             umgesetzt.

   Version 1.2: Ein-/Ausgabe-Pufferung, Umwandeln von Dateien, die
             ohne Leerzeichen an den Zeilen vorliegen in formatier-
             bare Textformate (Leerzeichen einfuegen, ausgenommen
             am Absatzende). Auf Anregung von Herrn Hinsch.

   Neue Fhigkeiten: MSWord: Erkennt automatisch Header.

   Fehler mit Umlauten UCSD --> 1ST Word beseitigt

   Konvertierung von Trennhilfe bei WordPlus eingefuehrt

   Version 1.3: TLGE-Format mit WordStar-Attributkonvertierung

   Version 1.6: Optionales Einfgen von Textattributen nach WS-Konvention

   Version 1.7: Neues G2E/G-Format

   Version 1.8a - Portierung nach Pure Pascal bzw. Turbo Pascal
   ANSI-Format hinzugefgt

   Version 1.9 - Filterung von ToolsBook-Wrterbuchformat nach ASCII
   (vorlufig) implementiert.

   Version 2.0 - Filterung nach ANSI mit Endlosabstzen eingebaut.
   Version 2.02 - Bug von ANSI-Endlos nach SIMPEL ausgebaut.

                                Shareware

   Begonnen: 14. 12. 85
   Stand:    17. 05. 94
   Portierung PP: 4. 8. 92, Januar 1993, Mai 93

             <<<---------- Der Superfilter ---------->>>

   PS.: Besonderer Dank an Martin Odersky und Peter Sollich, mit deren
   Modula-System die Urfassung des Programms entwickelt wurde.

   PPS: Peter Sollichs Purepascal gab Anla zur bertragung der Quellen
   nach Turbo/Pure-Pascal (zunchst nicht vollstndig ausgefhrt).

************************************************************************)

USES Crt, SuperBase, SuperUti;

CONST   Host128 =       FALSE;
        (* Gibt an, ob der Computer, auf dem das Programm laeuft,
           einen normalen (128) oder erweiterten Zeichensatz hat -
           fr Bildschirmanzeige im Analyse-Modus. *)
        WordByteSex =   TRUE;
        (* Gibt an, ob Bytes in WordInfo geflipt werden muessen *)

        escape =        #27;

TYPE    IOFile =                FILE;

VAR     EingabeFormat:          TextFormat; (* Aufzhlungstyp aus SuperBase *)
        AusgabeFormat:          TextFormat;
        TabFiltern:             BOOLEAN;
        Anzeigen:               BOOLEAN;
        DekodiereSteuer:        BOOLEAN;
        Analysieren:            BOOLEAN;
        AnalyseFormat:          TextFormat;
        AnalyseAnzeigen:        BOOLEAN;
        AnalyseLinefeed:        BOOLEAN;
        AnalyseControlZ:        BOOLEAN;
        Spalte:                 WORD;
        ZSpalte:                WORD;
        Tabspace, Umbruch:      WORD;
        Limit0, Limit1:         WORD;
        SteuerzeichenFiltern:   BOOLEAN;
        EingabeHatControlZ:     BOOLEAN;
        AusgabeHatControlZ:     BOOLEAN;
        EingabeHatLinefeed:     BOOLEAN;
        AusgabeHatLinefeed:     BOOLEAN;
        IBM:                    BOOLEAN;
        Prefixed:               BOOLEAN;
        BlankEinfuegen:         BOOLEAN;
        Indent:                 BOOLEAN;
        {MailBox:                BOOLEAN;}
        WSAttributeSetzen:      BOOLEAN;
        EinPfad, AusPfad:       eineInfo;
VAR     EinName, AusName:       eineInfo;

PROCEDURE ByteSex (VAR c: WORD);
VAR    High, Low:   WORD;
BEGIN
  IF WordByteSex THEN BEGIN
    High := c MOD 256; (* unteres Byte *)
    Low := c DIV 256;  (* oberes Byte *)
    c := High * 256 + Low;
  END (* IF *);
END (* ByteSex *);

CONST   cpuffer =       16000;

VAR
        puffer:                 ARRAY [0..cpuffer] OF CHAR;
        pindex, pende:          INTEGER;
        inh:                    IOFile (* INTEGER *);

        outpuffer:              ARRAY [0..cpuffer] OF CHAR;
        outindex, outende:      INTEGER;
        outh:                   IOFile (* INTEGER *);
        Ende:                   BOOLEAN;

PROCEDURE LiesPuffer (VAR h: IOFile (* Hier Filevariable! *));
(* Puffer nachladen, wenn pindex > pende *)
VAR       i:         WORD;
BEGIN
    pindex := cpuffer + 1; (* versuche, ganzen Block zu les. *)
    BlockRead (h, puffer, pindex, i);
    pende := i; (* Anzahl gelesener Zeichen *)
{Write ('LiesPuffer, pende: ', pende); ReadLn;}
    IF (pende > 0) THEN BEGIN
      pindex := 0; DEC (pende); (* Da 0-based, ist der gueltige Index
                                  die Anzahl Zeichen - 1 *)
                               (* Index auf 0, um Puffer vom Anfang aus-
                                  zulesen *)
    END
    ELSE BEGIN
      pindex := 1; (* pindex > pende! *)
      {Ende := TRUE; Close (h);}
    END (* IF *);
END (* LiesPuffer *);

PROCEDURE ReadRec (VAR rec (* : ARRAY OF WORD *); recSize: WORD);
{VAR  i:   LONGCARD;}
BEGIN
  BlockRead (inh, rec, recSize);
  (* ACHTUNG: File mu mit Byte-Recordgre erffnet worden sein *)
END (* ReadRec *);

PROCEDURE SchreibPuffer (VAR h: IOFile);
VAR geschrieben: WORD;
BEGIN
  BlockWrite (h, outpuffer, outindex, geschrieben);
  outindex := 0; (* Puffer wieder vom Anfang her beschreiben *)
END (* SchreibPuffer *);

PROCEDURE GetZeichen (VAR ch: CHAR);
BEGIN
  IF NOT ENDE THEN BEGIN
    ch := puffer [WORD (pindex)]; INC (pindex);
    (* pindex zeigt auf das Zeichen nach dem aktuellen Zeichen *)
    IF pindex > pende THEN BEGIN
      LiesPuffer (inh); Ende := Ende OR (pindex > pende);
    END (* IF *);
  END (* IF NOT ENDE *)
  ELSE ch := CHR (0);
END (* GetZeichen *);

PROCEDURE PutZeichen (ch: CHAR);
BEGIN
  outpuffer [WORD (outindex)] := ch;
  INC (outindex);
  IF (WORD (outindex) > cpuffer) THEN BEGIN
    SchreibPuffer (outh);
  END (* IF *);
END (* PutZeichen *);

(************* Eigentliche Filterprozedur **********************)

PROCEDURE Filtern;
VAR     EinPf, AusPf:           eineInfo;
        ZwischenCode:           CHAR;
        ZeilenEnde:             BOOLEAN;
        WordStarMarkiert:       BOOLEAN; (* WS-markierte Zeichen *)
        DieseZeileLeer:         BOOLEAN; (* Vormerker f. LetzteZeile.. *)
        LetzteZeileLeer:        BOOLEAN; (* markiert Nicht-WS-Absatz *)
        AbsatzMarkiert:         BOOLEAN; (* merkt Absatz-Markierung *)
        schreibBlank:           BOOLEAN; (* EingabeProzessor weist
                                            Ausgabe eines Blank nach
                                            d. lfd. Zeichen an *)
        TrennHilfe:             BOOLEAN; (* weiches Trennzeichen *)
        WordInf:                WordInfo;
        UCSDInf:                UCSDInfo;
        ZeichenZahl0:           WORD;
        ZeichenZahl1:           WORD;
        ZeichenZahl:            LONGINT;
        ZeilenZahl:             WORD;
        UCSDEin, UCSDAus:       WORD;
        Leergemerkt:            BOOLEAN; (* Letztes Zeichen war " " *)
        EinAttribut:            Attribut;
        AusAttribut:            Attribut;
        AttributGeschaltet:     BOOLEAN;
        dummy:                  CHAR;

  PROCEDURE IncUCSD;
  (* Diese Prozedur zaehlt den Zeichen-Ausgabezaehler fuer UCSD-Dateien
     weiter und fuellt ggf. die laufende Textseite mit ASCII-Nul auf *)
  VAR   i:      WORD;
  BEGIN
    IF AusgabeFormat = UCSD THEN BEGIN
      INC (UCSDAus);
      IF UCSDAus + 81 > 1024 THEN BEGIN
        FOR i := UCSDAus + 1 TO 1024 DO BEGIN
          PutZeichen (CHR (0));
        END (* FOR *);
        UCSDAus := 0;
      END (* IF *);
    END (* IF UCSD *);
  END (* IncUCSD *);

  PROCEDURE INCZaehler (VAR x0, x1: WORD);
  (* zaehlt den aus zwei 16-Bit-Zahlen bestehenden Zaehler der
     Eingabezeichen um 1 hoch *)
  BEGIN
    IF x0 < (* MAX (WORD) *) (* Standard! *)
            65535
      THEN INC (x0)
      ELSE BEGIN INC (x1); x0 := 0;
    END (* Zeichen zaehlen *);
  END (* INCZaehler *);

  PROCEDURE ZeigZeichen (Zeichen: CHAR);
  (* Zeigt waehrend des Filterns ein Zeichen auf dem Bildschirm an
     und zaehlt die Spalte in der Zeile fuer die korrekte Expandierung
     von TAB in Blanks mit *)
  BEGIN
    IF ZeilenEnde OR
       (* ((EingabeFormat = UCSD) & *) (ZeichenSatz (Zeichen) = CR)
      THEN BEGIN
           Spalte := 0; ZSpalte := 0; ZeilenEnde := FALSE;
           INC (ZeilenZahl);
           IF Anzeigen THEN BEGIN
             IF Analysieren THEN BEGIN
                IF WordStarMarkiert THEN BEGIN
                   Write ('<WCR>');
                END
                ELSE BEGIN Write ('<CR>');
                END (* ELSE *);
             END (* IF Analysieren *);
             WriteLn
           END (* IF Anzeigen *)
           ELSE BEGIN
             Write ('.');
             IF ZeilenZahl MOD 60 = 0 THEN WriteLn;
           END (* IF Anzeigen *);
    END (* IF ZeilenEnde *)
    ELSE BEGIN
           IF (ZeichenSatz (Zeichen) < SP) AND Anzeigen THEN BEGIN
            IF DekodiereSteuer THEN
             CASE ZeichenSatz (Zeichen) OF
               NUL:    BEGIN Write ('<NUL>'); INC (ZSpalte, 5); END;
               SOH:    BEGIN Write ('<SOH>'); INC (ZSpalte, 5); END;
               STX:    BEGIN Write ('<STX>'); INC (ZSpalte, 5); END;
               ETX:    BEGIN Write ('<ETX>'); INC (ZSpalte, 5); END;
               EOT:    BEGIN Write ('<EOT>'); INC (ZSpalte, 5); END;
               ENQ:    BEGIN Write ('<ENQ>'); INC (ZSpalte, 5); END;
               ACK:    BEGIN Write ('<ACK>'); INC (ZSpalte, 5); END;
               BEL:    BEGIN Write ('<BEL>'); INC (ZSpalte, 5); END;
               BS:     BEGIN Write ('<BS>'); INC (ZSpalte, 4); END;
               HT:     BEGIN Write ('<HT>'); INC (ZSpalte, 4); END;
               LF:     BEGIN Write ('<LF>'); INC (ZSpalte, 4); END;
               VT:     BEGIN Write ('<VT>'); INC (ZSpalte, 4); END;
               FF:     BEGIN Write ('<FF>'); INC (ZSpalte, 4); END;
               CR:     BEGIN Write ('<CR>'); INC (ZSpalte, 4); END;
               SO:     BEGIN Write ('<SO>'); INC (ZSpalte, 4); END;
               SI:     BEGIN Write ('<SI>'); INC (ZSpalte, 4); END;

               DLE:    BEGIN Write ('<DLE>'); INC (ZSpalte, 5); END;
               DC1:    BEGIN Write ('<DC1>'); INC (ZSpalte, 5); END;
               DC2:    BEGIN Write ('<DC2>'); INC (ZSpalte, 5); END;
               DC3:    BEGIN Write ('<DC3>'); INC (ZSpalte, 5); END;
               DC4:    BEGIN Write ('<DC4>'); INC (ZSpalte, 5); END;
               NAK:    BEGIN Write ('<NAK>'); INC (ZSpalte, 5); END;
               SYN:    BEGIN Write ('<SYN>'); INC (ZSpalte, 5); END;
               ETB:    BEGIN Write ('<ETB>'); INC (ZSpalte, 5); END;
               CAN:    BEGIN Write ('<CAN>'); INC (ZSpalte, 5); END;
               EM:     BEGIN Write ('<EM>');  INC (ZSpalte, 4); END;
               SUB:    BEGIN Write ('<SUB>'); INC (ZSpalte, 5); END;
               ESC:    BEGIN Write ('<ESC>'); INC (ZSpalte, 5); END;
               FS:     BEGIN Write ('<FS>');  INC (ZSpalte, 4); END;
               GS:     BEGIN Write ('<GS>');  INC (ZSpalte, 4); END;
               RS:     BEGIN Write ('<RS>');  INC (ZSpalte, 4); END;
               US:     BEGIN Write ('<US>');  INC (ZSpalte, 4); END;
             ELSE
               INC (ZSpalte, 2);
               Write ('^', CHR (ORD (Zeichen) + ORD (AtSig)));
             END (* CASE *)
            ELSE BEGIN
              INC (ZSpalte, 2);
              Write ('^', CHR (ORD (Zeichen) + ORD (AtSig)));
            END;
            IF Analysieren THEN BEGIN
              {INC (Spalte);}
              IF ZSpalte >= 70 THEN BEGIN
                WriteLn; ZSpalte := 0;
              END (* IF Spalte *);
            END (* IF Analysieren *)
            ELSE IF ZeichenSatz (Zeichen) > ESC THEN BEGIN
              INC (Spalte); (* div. weiche Trennzei. *)
            END (* IF Analysieren *);
           END (* IF ZeichenSatz *)
           ELSE BEGIN
             INC (Spalte); INC (ZSpalte);
             IF Anzeigen THEN BEGIN
               IF Analysieren AND (ZSpalte >= 70) THEN BEGIN
                 WriteLn; ZSpalte := 0;
               END (* IF Analysieren *);
               IF (ZeichenSatz (Zeichen) > DEL) AND Host128 THEN BEGIN
                 CASE ZeichenSatz (Zeichen) OF
                    (* Fuer Hostcomputer mit 128er Zeichensatz: *)
                           App:         Write ('[');
                           Opp:         Write ('\');
                           Upp:         Write (']');
                           kapp:        Write ('{');
                           kopp:        Write ('|');
                           kupp:        Write ('}');
                           sz:          Write ('~');
                           knTild:      Write ('n~');
                           NTild:       Write ('N~');
                           spanRuf:     Write ('i');
                           spanFrag:    Write ('S.');
                           Pts:         Write ('Pts.');
                           ELSE Write ('(', ORD (Zeichen):1, ')');
                 END (* CASE *);
               END (* IF Zeichen > DEL *)
               ELSE BEGIN
                 Write (Zeichen);
               END (* IF Zeichen > DEL *);
               IF (AusgabeFormat IN [MSWORD, ANSIEndlos])
                 AND (ZeichenZahl0 MOD 65 = 0) THEN BEGIN
                 WriteLn;
               END (* IF MSWORD & MOD 65 *);
             END (* IF Anzeigen *);
           END (* IF Zeichen < SP *);
    END (* IF nicht ZeilenEnde *);
  END (* ZeigZeichen *);

  PROCEDURE WSAttribute (VAR Zeichen: CHAR);
  BEGIN
           CASE ZeichenSatz (Zeichen) OF
             WSTrenn1: Zeichen := CHR (0);
             WSTrenn2: BEGIN
                         PutZeichen ('-'); (* Trennstrich *)
                         Zeichen := ' ';
                       END;
             STX: BEGIN
                    IF fett IN EinAttribut
                      THEN EXCL (EinAttribut, fett)
                      ELSE INCL (EinAttribut, fett);
                    Zeichen := CHR (ORD (NUL));
                    AttributGeschaltet := TRUE;
                  END;
             (* Was'n das - verschwunden??? *)
             EOT: BEGIN
                    IF doppel IN EinAttribut
                      THEN EXCL (EinAttribut, doppel)
                      ELSE INCL (EinAttribut, doppel);
                    Zeichen := CHR (ORD (NUL));
                    AttributGeschaltet := TRUE;
                  END;
             DC2: BEGIN
                    IF kursiv IN EinAttribut
                      THEN EXCL (EinAttribut, kursiv)
                      ELSE INCL (EinAttribut, kursiv);
                    Zeichen := CHR (ORD (NUL));
                    AttributGeschaltet := TRUE;
                  END;
             DC3: BEGIN
                    IF unterstrichen IN EinAttribut
                      THEN EXCL (EinAttribut, unterstrichen)
                      ELSE INCL (EinAttribut, unterstrichen);
                    Zeichen := CHR (ORD (NUL));
                    AttributGeschaltet := TRUE;
                  END;
             CAN: BEGIN
                    IF hell IN EinAttribut
                      THEN EXCL (EinAttribut, hell)
                      ELSE INCL (EinAttribut, hell);
                    Zeichen := CHR (ORD (NUL));
                    AttributGeschaltet := TRUE;
                  END;
             DC4: BEGIN
                    IF hochgestellt IN EinAttribut
                      THEN EXCL (EinAttribut, hochgestellt)
                      ELSE INCL (EinAttribut, hochgestellt);
                    Zeichen := CHR (ORD (NUL));
                    AttributGeschaltet := TRUE;
                  END;
             SYN: BEGIN
                    IF tiefgestellt IN EinAttribut
                      THEN EXCL (EinAttribut, tiefgestellt)
                      ELSE INCL (EinAttribut, tiefgestellt);
                    Zeichen := CHR (ORD (NUL));
                    AttributGeschaltet := TRUE;
                  END;

             WSRETURN, WSVorMark, WSEndMark, WSVorMarkHigh,
             WSSpace, CR:;

             ELSE IF ZeichenSatz (ORD (Zeichen)) < SP THEN BEGIN
                     Zeichen := CHR (ORD (NUL));
                  END (* IF *);
           END (* CASE *);
  END (* WSAttribute *);

  PROCEDURE SMAttribute (VAR Zeichen: CHAR);
  BEGIN
         IF ZeichenSatz (ORD (Zeichen)) = ESC THEN BEGIN
           GetZeichen (Zeichen);
           INCZaehler (ZeichenZahl0, ZeichenZahl1);
           (* Effektiv gelesenes Eingabezeichen *)
           CASE ZeichenSatz (ORD (Zeichen) MOD 128) OF
             NUL: BEGIN
                    EinAttribut := [];
                    Zeichen := CHR (ORD (NUL));
                    AttributGeschaltet := TRUE;
                  END;
             SOH: BEGIN
                    EinAttribut := [unterstrichen];
                    Zeichen := CHR (ORD (NUL));
                    AttributGeschaltet := TRUE;
                  END;
             STX: BEGIN
                    EinAttribut := [fett];
                    Zeichen := CHR (ORD (NUL));
                    AttributGeschaltet := TRUE;
                  END;
             ETX: BEGIN
                    EinAttribut := [fett, unterstrichen];
                    Zeichen := CHR (ORD (NUL));
                    AttributGeschaltet := TRUE;
                  END;
             EOT: BEGIN
                    EinAttribut := [hochgestellt];
                    Zeichen := CHR (ORD (NUL));
                    AttributGeschaltet := TRUE;
                  END;
             ENQ: BEGIN
                    EinAttribut := [unterstrichen, hochgestellt];
                    Zeichen := CHR (ORD (NUL));
                    AttributGeschaltet := TRUE;
                  END;
             ACK: BEGIN
                    EinAttribut := [fett, hochgestellt];
                    Zeichen := CHR (ORD (NUL));
                    AttributGeschaltet := TRUE;
                  END;
             BEL: BEGIN
                    EinAttribut := [fett, unterstrichen, hochgestellt];
                    Zeichen := CHR (ORD (NUL));
                    AttributGeschaltet := TRUE;
                  END;
             ELSE;
           END (* CASE *);
         END (* IF *);
  END (* SMAttribute *);

  PROCEDURE LiesFirstWord (VAR Zeichen: CHAR);
  BEGIN
    CASE ZeichenSatz (Zeichen) OF
      ESC: BEGIN
             GetZeichen (Zeichen);
             AttributGeschaltet := TRUE;
             EinAttribut := {Attribut} [Attribute (ORD (Zeichen) - 128)];
             Zeichen := CHR (ORD (NUL));
           END;
      VT:  BEGIN
             GetZeichen (Zeichen);
             Zeichen := CHR (ORD (NUL));
           END;
      FF:  BEGIN
             Zeichen := CHR (ORD (NUL));
             ZeilenEnde := TRUE; LetzteZeileLeer := FALSE;
             DieseZeileLeer := TRUE;
             ZeigZeichen (CHR (ORD (CR)));
             PutZeichen (CHR (ORD (CR)));
             IF AusgabeHatLinefeed THEN PutZeichen (CHR (ORD (LF)));
           END;
      FWTrenn: BEGIN
                 Zeichen := '-'; schreibBlank := TRUE;
                 TrennHilfe := TRUE;
               END;
      FWForm: BEGIN
                REPEAT (* Formatanweisung *)
                  GetZeichen (Zeichen);
                UNTIL ZeichenSatz (Zeichen) = CR;
                IF EingabeHatLinefeed THEN BEGIN
                  GetZeichen (Zeichen);
                END (* IF *);
                Zeichen := CHR (ORD (NUL));
              END;
      FWStretch, FWIndent, FWVarSpace: Zeichen := ' ';
      SOH..BS,
      SO, SI: Zeichen := CHR (ORD (FrageZ));
      DLE..CAN: Zeichen := CHR (ORD (Zeichen) - ORD (DLE) + ORD (Null));
      ELSE;
    END (* CASE *);
  END (* LiesFirstWord *);

  PROCEDURE LiesUCSD (VAR Zeichen: CHAR);
  BEGIN
    Zeichen := CHR (ORD (Zeichen) MOD 128);
    IF (AusgabeFormat IN [WS30GER, GERASCII128, FIRSTWORD,
                                  SMTEXT, WS34MSDOS, MSWORD])
      THEN BEGIN
           CASE Zeichen OF
             '[':  Zeichen := CHR (ORD (App));
             '\':  Zeichen := CHR (ORD (Opp));
             ']':  Zeichen := CHR (ORD (Upp));
             '{':  Zeichen := CHR (ORD (kapp));
             '|':  Zeichen := CHR (ORD (kopp));
             '}':  Zeichen := CHR (ORD (kupp));
             '~':  Zeichen := CHR (ORD (sz));
             ELSE;
           END (* CASE Zeichen *);
      END
      ELSE IF (AusgabeFormat = WS30SPA) THEN BEGIN
             CASE Zeichen OF
               '[':  Zeichen := CHR (ORD (spanRuf));
               '\':  Zeichen := CHR (ORD (NTild));
               ']':  Zeichen := CHR (ORD (spanFrag));
               '{':  Zeichen := CHR (ORD (pp));
               '|':  Zeichen := CHR (ORD (knTild));
               '}':  Zeichen := CHR (ORD (upp));
               '~':  Zeichen := CHR (ORD (sz));
               ELSE;
             END (* CASE Zeichen *);
       END (* IF *);
  END (* LiesUCSD *);

  PROCEDURE LiesZeichen (VAR Zeichen: CHAR);
  (* Liest ein Zeichen vom Eingabetext und wandelt es in das interne
     Universalformat um *)
  VAR   dummy:  CHAR;
  BEGIN
    GetZeichen (Zeichen);
    IF EingabeFormat = UCSD THEN BEGIN
      (* Eventuell fuellende ASCII-NUL entfernen: *)
      WHILE (ZeichenSatz (Zeichen) = NUL) AND NOT (pindex > pende)
                                             (* EOS (Eingabe) *) DO BEGIN
        GetZeichen (Zeichen);
      END (* WHILE *);
    END (* IF EingabeFormat = UCSD *);

    IF Prefixed AND (ZeichenSatz (Zeichen) = Akz1)
    (* Soll durch Tabelle ersetzt werden! *)
      THEN BEGIN
        GetZeichen (Zeichen);
        CASE ZeichenSatz (Zeichen) OF
          kc: Zeichen := CHR (ORD (cedill));
          C: Zeichen := CHR (ORD (Cedill));
          I: Zeichen := CHR (ORD (spanRuf));
          ELSE;
        END (* CASE *);
    END (* IF Prefixed *);

    INCZaehler (ZeichenZahl0, ZeichenZahl1);
    Ende := (ZeichenZahl0 >= Limit0) AND (ZeichenZahl1 >= Limit1);
      (* Effektiv gelesenes Eingabezeichen *)

    IF EingabeFormat IN [WS30DOC, WS30GER, WS30SPA, WS34MSDOS{, SIMPEL}]
      THEN BEGIN WSAttribute (Zeichen) END
    ELSE BEGIN
       IF EingabeFormat = SMTEXT THEN BEGIN SMAttribute (Zeichen) END;
    END (* IF WSAttribute *);

    CASE EingabeFormat OF

      FIRSTWORD, G2E: LiesFirstWord (Zeichen);

      (* Ruecksetzen des obersten Bits - dabei wird in jedem Fall aus
         dem weichen ein hartes CR bei WordStar-Dateien: *)
      USASCII128, WS30DOC:    BEGIN
                                WordStarMarkiert :=
                                   ZeichenSatz (Zeichen) > DEL;
                                Zeichen := CHR (ORD (Zeichen) MOD 128);
                              END;

      GERASCII128, WS30GER:   BEGIN
                                WordStarMarkiert :=
                                   ZeichenSatz (Zeichen) > DEL;
                                Zeichen := CHR (ORD (Zeichen) MOD 128);
                                CASE Zeichen OF
                                  '[':  Zeichen := CHR (ORD (App));
                                  '\':  Zeichen := CHR (ORD (Opp));
                                  ']':  Zeichen := CHR (ORD (Upp));
                                  '{':  Zeichen := CHR (ORD (kapp));
                                  '|':  Zeichen := CHR (ORD (kopp));
                                  '}':  Zeichen := CHR (ORD (kupp));
                                  '~':  Zeichen := CHR (ORD (sz));
                                  ELSE;
                                END (* CASE Zeichen *);
                              END;
      ANSI, ANSIEndlos,
      TOOLBOOK:               BEGIN
                                CASE Zeichen OF
                                  CHR (ORD (LF)): Zeichen := CHR (ORD (CR));
                                  CHR (ORD (US)):
                                  IF Eingabeformat = TOOLBOOK THEN
                                  BEGIN
                                    GetZeichen (Zeichen);
                                    CASE Zeichen OF
                                      CHR (ORD (LF)): BEGIN
                                             Zeichen := CHR (ORD (CR));
                                           END;
                                      'a': (* Kleines a, nach ^_, scheint Ende
                                              des Stichwortes anzuzeigen ... *)
                                           BEGIN
                                             Zeichen := CHR (ORD (NUL));
                                           END;
                                      'A': (* Groes A, nach ^_, scheint Anfang
                                              des Stichwortes anzuzeigen ... *)
                                           BEGIN
                                             Zeichen := CHR (ORD (NUL));
                                             PutZeichen (CHR (ORD (Z249)));
                                             PutZeichen (' ');
                                           END;
                                    END (* CASE *);
                                  END (* US *);
                                  CHR (ORD (kaAigu)):
                                       BEGIN
                                         Zeichen := CHR (ORD (NUL));
                                       END;
                                  AnsiSpanRuf:  Zeichen := CHR (ORD (spanRuf));
                                  AnsiCent:     Zeichen := CHR (ORD (cent));
                                  AnsiPfund:    Zeichen := CHR (ORD (pound));
                                  AnsiYen:      Zeichen := CHR (ORD (Yen));
                                  AnsiBar:      Zeichen := CHR (ORD (SenkrStrich));
                                  AnsiPara:     Zeichen := CHR (ORD (NAK));
                                  AnsiPP:       Zeichen := CHR (ORD (pp));
                                  AnsiCopyR:    Zeichen := CHR (ORD (CopyR));
                                  Ansikaunter:  Zeichen := CHR (ORD (FemOrd));
                                  AnsiFranzabf: Zeichen := CHR (ORD (Abf));
                                  AnsiNegation: Zeichen := CHR (ORD (Neg));
                                  (* Ansi173 *)
                                  (* Ansi175 *)
                                  AnsiGrad:     Zeichen := CHR (ORD (Grad));
                                  AnsiPM:       Zeichen := CHR (ORD (PM));
                                  AnsiHoch2:    Zeichen := CHR (ORD (H2));
                                  AnsiHoch3:    Zeichen := CHR (ORD (H3));
                                  AnsiAigu:     Zeichen := '''';
                                  AnsiMue:      Zeichen := CHR (ORD (my));
                                  AnsiParagraph: Zeichen := '^'; (* ??? *)
                                  AnsiHoch1:    Zeichen := '1'; (* ??? *)
                                  AnsiEinviertel: Zeichen := CHR (ORD (viert));
                                  AnsiEinhalb:  Zeichen := CHR (ORD (halb));
                                  AnsiDreiviertel: BEGIN
                                                PutZeichen ('3');
                                                PutZeichen ('/');
                                                PutZeichen ('4');
                                                  END;
                                  AnsiSpanFrag: Zeichen := CHR (ORD (SpanFrag));
                                  AnsiAgrave:   Zeichen := 'A'; (* ??? *)
                                  AnsiAaigu:    Zeichen := 'A'; (* ??? *)
                                  AnsiAdach:    Zeichen := 'A';
                                  AnsiAtild:    Zeichen := 'A';
                                  AnsiApp:      Zeichen := CHR (ORD (App));
                                  AnsiAo:       Zeichen := CHR (ORD (Ao));
                                  AnsiAe:       Zeichen := CHR (ORD (Ae));
                                  AnsiCedill:   Zeichen := CHR (ORD (Cedill));
                                  AnsiEgrave:   Zeichen := 'E';
                                  AnsiEaigu:    Zeichen := CHR (ORD (EAig));
                                  AnsiEdach:    Zeichen := 'E';
                                  AnsiEpp:      Zeichen := 'E';
                                  AnsiIgrave:   Zeichen := 'I';
                                  AnsiIaigu:    Zeichen := 'I';
                                  AnsiIdach:    Zeichen := 'I';
                                  AnsiIpp:      Zeichen := 'I';
                                  AnsiDstrich:  Zeichen := 'D';
                                  AnsiNTild:    Zeichen := CHR (ORD (NTild));
                                  AnsiOgrave:   Zeichen := 'O';
                                  AnsiOaigu:    Zeichen := 'O';
                                  AnsiOdach:    Zeichen := CHR (ORD (OCirc));
                                  AnsiOtild:    Zeichen := 'O';
                                  AnsiOpp:      Zeichen := CHR (ORD (Opp));
                                  AnsiOslash:   Zeichen := CHR (ORD (Z237));
                                  AnsoUgrave:   Zeichen := 'U';
                                  AnsiUaigu:    Zeichen := 'U';
                                  AnsiUdach:    Zeichen := 'U';
                                  AnsiUpp:      Zeichen := CHR (ORD (Upp));
                                  AnsiYaigu:    Zeichen := 'Y';
                                  Ansi222:      Zeichen := 'p';

                                  AnsiSZ:       Zeichen := CHR (ORD (sz));

                                  Ansikagrave:  Zeichen := CHR (ORD (kagrav));
                                  Ansikaaigu:   Zeichen := CHR (ORD (kaAigu));
                                  Ansikadach:   Zeichen := CHR (ORD (kaCirc));
                                  Ansikatild:   Zeichen := 'a';
                                  Ansikapp:     Zeichen := CHR (ORD (kapp));
                                  Ansikao:      Zeichen := CHR (ORD (kao));
                                  Ansikae:      Zeichen := CHR (ORD (kae));
                                  Ansikcedill:  Zeichen := CHR (ORD (kcedill));
                                  AnsikeGrave:  Zeichen := CHR (ORD (keGrav));
                                  AnsikeAigu:   Zeichen := CHR (ORD (keAigu));
                                  AnsikeDach:   Zeichen := CHR (ORD (keCirc));
                                  Ansikepp:     Zeichen := CHR (ORD (kepp));
                                  AnsikiGrave:  Zeichen := CHR (ORD (kiGrav));
                                  AnsikiAigu:   Zeichen := CHR (ORD (kiAigu));
                                  AnsikiDach:   Zeichen := CHR (ORD (kiCirc));
                                  Ansikipp:     Zeichen := CHR (ORD (kipp));
                                  Ansi240:      Zeichen := 'o'; (* ??? *)
                                  AnsiknTild:   Zeichen := CHR (ORD (knTild));
                                  AnsiReg:      Zeichen := CHR (ORD (Reg));
                                  AnsikoGrave:  Zeichen := CHR (ORD (koGrav));
                                  AnsikoAigu:   Zeichen := CHR (ORD (koAigu));
                                  AnsikoDach:   Zeichen := 'o';
                                  AnsikoTild:   Zeichen := CHR (ORD (koTild));
                                  Ansikopp:     Zeichen := CHR (ORD (kopp));

                                  AnsikuGrave:  Zeichen := CHR (ORD (kuGrav));
                                  AnsikuAigu:   Zeichen := CHR (ORD (kuAigu));
                                  AnsikuDach:   Zeichen := CHR (ORD (kuCirc));
                                  Ansikupp:     Zeichen := CHR (ORD (kupp));
                                  AnsikyAigu:   Zeichen := 'y';
                                  Ansi254:      Zeichen := 'p'; (* ??? *)
                                  Ansikypp:     Zeichen := CHR (ORD (kypp));

                                  ELSE;
                                END (* CASE Zeichen *);
                              END;

      WS30SPA:                BEGIN
                                WordStarMarkiert :=
                                   ZeichenSatz (Zeichen) > DEL;
                                Zeichen := CHR (ORD (Zeichen) MOD 128);
                                CASE Zeichen OF
                                  '[':  Zeichen := CHR (ORD (spanRuf));
                                  '\':  Zeichen := CHR (ORD (NTild));
                                  ']':  Zeichen := CHR (ORD (spanFrag));
                                  '{':  Zeichen := CHR (ORD (pp));
                                  '|':  Zeichen := CHR (ORD (knTild));
                                  '}':  Zeichen := CHR (ORD (kupp));
                                  '~':  Zeichen := CHR (ORD (sz));
                                  ELSE;
                                END (* CASE Zeichen *);
                              END;

      WS34MSDOS:              BEGIN
                                CASE ZeichenSatz (Zeichen) OF
                                  WSVorMark, WSVorMarkHigh: BEGIN
                                    WordStarMarkiert :=
                                      ZeichenSatz (Zeichen) =
                                        WSVorMarkHigh;
                                    GetZeichen (Zeichen);
                                    GetZeichen (dummy);
                                  END;
                                  ELSE BEGIN
                                     WordStarMarkiert :=
                                         ZeichenSatz (Zeichen) > DEL;
                                       Zeichen := CHR (ORD (Zeichen)
                                                  MOD 128);
                                  END (* ELSE *);
                                END (* CASE *);
                              END;

      UCSD: LiesUCSD (Zeichen);

      SMTEXT:                 BEGIN
                                Zeichen := CHR (ORD (Zeichen) MOD 128);
                                CASE Zeichen OF
                                  '}':  Zeichen := CHR (ORD (App));
                                  '{':  Zeichen := CHR (ORD (Opp));
                                  '\':  Zeichen := CHR (ORD (Upp));
                                  ']':  Zeichen := CHR (ORD (kapp));
                                  '[':  Zeichen := CHR (ORD (kopp));
                                  '|':  Zeichen := CHR (ORD (kupp));
                                  '~':  Zeichen := CHR (ORD (sz));
                                  ELSE;
                                END (* CASE Zeichen *);
                              END;

      MSWORD:                 BEGIN
                                CASE ZeichenSatz (Zeichen) OF
                                  WordTrenn: BEGIN
                                               GetZeichen (Zeichen);
                                               INCZaehler (ZeichenZahl0,
                                                   ZeichenZahl1);
                                             END;
                                  LF, VT, FF:
                                    BEGIN
                                      Zeichen := CHR (ORD (0));
                                      ZeilenEnde := TRUE;
                                      LetzteZeileLeer := FALSE;
                                      DieseZeileLeer := TRUE;
                                      ZeigZeichen (CHR (ORD (CR)));
                                      PutZeichen (CHR (ORD (CR)));
                                      IF AusgabeHatLinefeed THEN BEGIN
                                        PutZeichen (CHR (ORD (LF)));
                                      END (* IF *);
                                    END;
                                  ELSE;
                                END (* Word-Sonderzeichen ueberlesen *);
                              END;
      ELSE;
    END (* CASE EingabeFormat *);

    IF IBM THEN BEGIN
      IF ZeichenSatz (Zeichen) = Pts THEN BEGIN
        Zeichen := CHR (ORD (sz));
      END (* IF *);
    END (* IF IBM *);

    (* Datei zu Ende? *)
    Ende := (* (EOS (Eingabe)) *)
            Ende OR
            (pindex > pende) OR
            ((ZeichenSatz (Zeichen) = SUB) AND EingabeHatControlZ) OR
            ((EingabeFormat = MSWORD) AND (ZeichenZahl0 >= WordInf.Anzahl0) AND
             (ZeichenZahl1 = WordInf.Anzahl1));


    (* Ev. Linefeed ueberlesen *)
    IF (ZeichenSatz (Zeichen) = CR) AND EingabeHatLinefeed THEN BEGIN
      GetZeichen (dummy);
    END
    ELSE IF (ZeichenSatz (Zeichen) = CR) THEN BEGIN
      Zeichen := CHR (ORD (CR));
    END (* IF *);

    (* Zeilenende erreicht? *)
    ZeilenEnde := (Ende) OR (ZeichenSatz (Zeichen) = CR);


    (* Markieren, ob eine Leerzeile (Absatz) aufgetreten ist *)
    IF ZeilenEnde THEN BEGIN
      IF EingabeFormat IN [MSWORD, ANSIEndlos] THEN BEGIN
        LetzteZeileLeer := TRUE;
      END
      ELSE BEGIN LetzteZeileLeer := DieseZeileLeer;
      END (* IF MSWORD *);
      DieseZeileLeer := TRUE; (* Noch wurde in dieser Zeile
                                      nichts gelesen *)
    END (* IF ZeilenEnde *)
    ELSE BEGIN
         IF (ZeichenSatz (Zeichen) <> SP) THEN BEGIN
           LetzteZeileLeer := DieseZeileLeer; (* ??????? 20. 8. 87 *)
           DieseZeileLeer := FALSE; (* Irgendwas anderes als
                                         Leerzeichen in der Zeile *)
         END (* IF # SP *);
    END (* IF ZeilenEnde... *);

  END (* LiesZeichen *);

  PROCEDURE SchreibAttribut (VAR Zeichen: CHAR);
  VAR     SMAtt:        SMAttribut;
          Format:       TextFormat;
          Diff:         Attribut;
  BEGIN
    Format := AusgabeFormat;
    IF WSAttributeSetzen THEN BEGIN AusgabeFormat := WS34MSDOS; END;
         AttributGeschaltet := FALSE;
         CASE AusgabeFormat OF
           FIRSTWORD, G2E: BEGIN
                      Zeichen := CHR ((BYTE (EinAttribut) MOD 64)
                                      + 128);
                      PutZeichen (CHR (ORD (ESC)));
                      PutZeichen (Zeichen);
           END;
           SMTEXT:  BEGIN
                      PutZeichen (CHR (ORD (ESC)));
                      SMAtt := [];
                      IF fett IN EinAttribut THEN BEGIN
                        SMAtt := SMAtt + [SMfett];
                      END (* IF *);
                      IF hell IN EinAttribut THEN BEGIN
                        SMAtt := SMAtt + [SMunterstrichen];
                      END (* IF *);
                      IF kursiv IN EinAttribut THEN BEGIN
                        SMAtt := SMAtt + [SMunterstrichen];
                      END (* IF *);
                      IF unterstrichen IN EinAttribut THEN BEGIN
                        SMAtt := SMAtt + [SMunterstrichen];
                      END (* IF *);
                      IF hochgestellt IN EinAttribut THEN BEGIN
                        SMAtt := SMAtt + [SMinvertiert];
                      END (* IF *);
                      IF tiefgestellt IN EinAttribut THEN BEGIN
                        SMAtt := SMAtt + [SMinvertiert];
                      END (* IF *);
                      Zeichen := CHR (BYTE (SMAtt));
                      PutZeichen (Zeichen);
                    END;
           WS30DOC..WS34MSDOS, SIMPEL: BEGIN
             SymmDiff (Diff, EinAttribut, AusAttribut);
             IF fett IN Diff
               THEN PutZeichen (CHR (ORD (STX)));;
             (* END IF *);
             IF doppel IN Diff
               THEN PutZeichen (CHR (ORD (EOT)));
             (* END IF *);
             IF unterstrichen IN Diff
               THEN PutZeichen (CHR (ORD (DC3)));
             (* END IF *);
             IF kursiv IN Diff
               THEN PutZeichen (CHR (ORD (DC2)));
             (* END IF *);
             IF hell IN Diff
               THEN PutZeichen (CHR (ORD (CAN)));
             (* END IF *);
             IF hochgestellt IN Diff
               THEN PutZeichen (CHR (ORD (DC4)));
             (* END IF *);
             IF tiefgestellt IN Diff
               THEN PutZeichen (CHR (ORD (SYN)));
             (* END IF *);
            END;
             ELSE;
           END (* CASE *);
    AusAttribut := EinAttribut;
    AusgabeFormat := Format;
  END (* SchreibAttribut *);

  PROCEDURE SchreibSonderZeichen (VAR Zeichen: CHAR);
  BEGIN
    (* Umlaute in anderen Zeichensatz umwandeln: *)
      CASE AusgabeFormat OF
        ANSI, ANSIEndlos, TOOLBOOK: BEGIN
          CASE ZeichenSatz (Zeichen) OF
            App:        Zeichen := AnsiApp;
            Opp:        Zeichen := AnsiOpp;
            Upp:        Zeichen := AnsiUpp;
            kapp:       Zeichen := Ansikapp;
            kopp:       Zeichen := Ansikopp;
            kupp:       Zeichen := Ansikupp;
            sz{, Pts}:    Zeichen := AnsiSZ;
            spanRuf:    Zeichen := AnsiSpanRuf;
            cent:       Zeichen := AnsiCent;
            pound:      Zeichen := AnsiPfund;
            Yen:        Zeichen := AnsiYen;
            {SenkrStrich: Zeichen := AnsiBar;}
            NAK:        Zeichen := AnsiPara;
            my:         Zeichen := AnsiMue;
            SpanFrag:   Zeichen := AnsiSpanFrag;
            Cedill:     Zeichen := AnsiCedill;
            kcedill:    Zeichen := Ansikcedill;
            NTild:      Zeichen := AnsiNTild;
            knTild:     Zeichen := AnsiknTild;
            pp:         Zeichen := AnsiPP;
            CopyR:      Zeichen := AnsiCopyR;
            Reg:        Zeichen := AnsiReg;
            FemOrd:     Zeichen := Ansikaunter;
            Abf:        Zeichen := AnsiFranzabf;
            Neg:        Zeichen := AnsiNegation;
            (* Ansi173 *)
            NegBack:    Zeichen := AnsiReg; (* ??? *)
            (* Ansi175 *)
            Grad:       Zeichen := AnsiGrad;
            PM:         Zeichen := AnsiPM;
            H2:         Zeichen := AnsiHoch2;
            H3:         Zeichen := AnsiHoch3;
            AnfE:       Zeichen := AnsiAigu;
            Power:      Zeichen := AnsiParagraph; (* ??? *)
            {AnsiHoch1:    Zeichen := '1'; (* ??? *)}
            viert:      Zeichen := AnsiEinviertel;
            halb:       Zeichen := AnsiEinhalb;
            {AnsiDreiviertel: BEGIN
                          Write ('3/4');
                            END;}
            {AnsiAgrave:   Zeichen := 'A'; (* ??? *)
            AnsiAaigu:    Zeichen := 'A'; (* ??? *)
            AnsiAdach:    Zeichen := 'A';
            AnsiAtild:    Zeichen := 'A';
            }
            Ao:           Zeichen := AnsiAo;
            Ae:           Zeichen := AnsiAe;
            {AnsiEgrave:   Zeichen := 'E';}
            EAig:         Zeichen := AnsiEaigu;
            {
            AnsiEdach:    Zeichen := 'E';
            AnsiEpp:      Zeichen := 'E';
            AnsiIgrave:   Zeichen := 'I';
            AnsiIaigu:    Zeichen := 'I';
            AnsiIdach:    Zeichen := 'I';
            AnsiIpp:      Zeichen := 'I';
            AnsiDstrich:  Zeichen := 'D';
            AnsiOgrave:   Zeichen := 'O';
            AnsiOaigu:    Zeichen := 'O';
            }
            OCirc:        Zeichen := AnsiOdach;
            {AnseOtild:    Zeichen := 'O';}
            Z237:         Zeichen := AnsiOslash;
            {AnsoUgrave:   Zeichen := 'U';
            AnsiUaigu:    Zeichen := 'U';
            AnsiUdach:    Zeichen := 'U';
            }
            {
            AnsiYaigu:    Zeichen := 'Y';
            Ansi222:      Zeichen := 'p';
            }

            kagrav:       Zeichen := Ansikagrave;
            kaAigu:       Zeichen := Ansikaaigu;
            kaCirc:       Zeichen := Ansikadach;
            {Ansikatild:   Zeichen := 'a';}
            kao:          Zeichen := Ansikao;
            kae:          Zeichen := Ansikae;
            keGrav:       Zeichen := AnsikeGrave;
            keAigu:       Zeichen := AnsikeAigu;
            keCirc:       Zeichen := AnsikeDach;
            kepp:         Zeichen := Ansikepp;
            kiGrav:       Zeichen := AnsikiGrave;
            kiAigu:       Zeichen := AnsikiAigu;
            kiCirc:       Zeichen := AnsikiDach;
            kipp:         Zeichen := Ansikipp;
            {Ansi240:      Zeichen := 'o'; (* ??? *)}
            koGrav:       Zeichen := AnsikoGrave;
            koAigu:       Zeichen := AnsikoAigu;
            {AnsikoDach:   Zeichen := 'o';}
            koTild:       Zeichen := AnsikoTild;

            kuGrav:       Zeichen := AnsikuGrave;
            kuAigu:       Zeichen := AnsikuAigu;
            kuCirc:       Zeichen := AnsikuDach;
            {AnsikyAigu:   Zeichen := 'y';
            Ansi254:      Zeichen := 'p'; (* ??? *)
            }
            kypp:         Zeichen := Ansikypp;
            ELSE;
          END (* CASE ZeichenSatz *);
        END;
        GERASCII128, WS30GER, UCSD: BEGIN
          CASE ZeichenSatz (Zeichen) OF
            App:        Zeichen := '[';
            Opp:        Zeichen := '\';
            Upp:        Zeichen := ']';
            kapp:       Zeichen := '{';
            kopp:       Zeichen := '|';
            kupp:       Zeichen := '}';
            sz, Pts:    Zeichen := '~';
            SP:         IF (AusgabeFormat = WS30GER) AND Leergemerkt AND
                          NOT DieseZeileLeer THEN BEGIN
                           Zeichen := CHR (ORD (WSSpace));
                        END (* IF *);
            ELSE;
          END (* CASE ZeichenSatz *);
        END;
        WS30SPA: BEGIN
          CASE ZeichenSatz (Zeichen) OF
            spanRuf:    Zeichen := '[';
            NTild:      Zeichen := '\';
            spanFrag:   Zeichen := ']';
            pp:         Zeichen := '{';
            knTild:      Zeichen := '|';
            kupp:       Zeichen := '}';
            sz, Pts:    Zeichen := '~';
            SP:         IF Leergemerkt AND NOT DieseZeileLeer THEN BEGIN
                          Zeichen := CHR (ORD (WSSpace));
                        END (* IF *);
            ELSE;
          END (* CASE ZeichenSatz *);
        END;
        SMTEXT: BEGIN
          CASE ZeichenSatz (Zeichen) OF
            App:        Zeichen := '}';
            Opp:        Zeichen := '{';
            Upp:        Zeichen := '\';
            kapp:       Zeichen := ']';
            kopp:       Zeichen := '[';
            kupp:       Zeichen := '|';
            sz, Pts:    Zeichen := '~';
            ELSE;
          END (* CASE ZeichenSatz *);
        END;
        WS34MSDOS: BEGIN
                      IF (ZeichenSatz (Zeichen) >= Cedill) THEN BEGIN
                        IF WordStarMarkiert
                          THEN PutZeichen (CHR (ORD (WSVorMarkHigh)))
                          ELSE PutZeichen (CHR (ORD (WSVorMark)));
                        (* END IF *);
                      END
                      ELSE IF ZeichenSatz (Zeichen) = SP THEN BEGIN
                         IF Leergemerkt AND NOT DieseZeileLeer
                           THEN Zeichen := CHR (ORD (WSSpace));
                         (* END IF *);
                      END (* IF *);
                    END;
        FIRSTWORD: BEGIN
                     CASE ZeichenSatz (Zeichen) OF
                       SP: BEGIN
                              IF NOT DieseZeileLeer THEN BEGIN
                                IF Leergemerkt
                                  THEN Zeichen := CHR (ORD (FWStretch))
                                  ELSE Zeichen := CHR (ORD (FWVarSpace));
                                (* END IF Leergemerkt *);
                              END
                              ELSE BEGIN
                                IF Indent
                                  THEN Zeichen := CHR (ORD (FWIndent))
                                  ELSE Zeichen := CHR (ORD (SP));
                              END (* DieseZeileLeer *);
                           END;
                      ELSE;
                      END (* CASE *);
                    END;
        MSWORD, SIMPEL, G2E,
        ASCII256:     ;
        ELSE
          CASE ZeichenSatz (Zeichen) OF
            App: BEGIN  PutZeichen ('A'); Zeichen := 'e';
                        ZeigZeichen ('A');
                 END;
            Opp: BEGIN  PutZeichen ('O'); Zeichen := 'e';
                        ZeigZeichen ('O');
                 END;
            Upp: BEGIN  PutZeichen ('U'); Zeichen := 'e';
                        ZeigZeichen ('U');
                 END;
            kapp: BEGIN PutZeichen ('a'); Zeichen := 'e';
                        ZeigZeichen ('a');
                 END;
            kopp: BEGIN PutZeichen ('o'); Zeichen := 'e';
                        ZeigZeichen ('o');
                 END;
            kupp: BEGIN PutZeichen ('u'); Zeichen := 'e';
                        ZeigZeichen ('u');
                 END;
            sz, Pts: BEGIN PutZeichen ('s'); Zeichen := 's';
                           ZeigZeichen ('s');
                     END;
            ELSE;
          END (* CASE ZeichenSatz *);
      END (* CASE AusgabeFormat *);
  END (* SchreibSonderZeichen *);

  PROCEDURE SchreibZeichen (Zeichen: CHAR);
  VAR   s:      WORD;
        dummy:  CHAR;
  BEGIN
    (* Control-Z-Textende schreiben: *)
    IF Ende AND AusgabeHatControlZ THEN
      PutZeichen (CHR (ORD (SUB)))
    ELSE IF SteuerZeichenFiltern AND (ZeichenSatz (Zeichen) IN
      [NUL .. BS, VT .. FF, SO .. US]) THEN EXIT

    ELSE BEGIN

      IF (NOT AusgabeHatControlZ AND (ZeichenSatz (Zeichen) = SUB)) OR
         (ZeichenSatz (Zeichen) = NUL) THEN BEGIN
             IF (ZeichenSatz (Zeichen) = NUL) AND AttributGeschaltet
               THEN SchreibAttribut (Zeichen);
             (* END IF *);
             EXIT;
      END (* IF *);

      SchreibSonderZeichen (Zeichen);
        (* wandelt Zeichen um und/oder schreibt Vorlaufzeichen *)

      IF BlankEinfuegen AND NOT LetzteZeileLeer AND
         (ZeichenSatz (Zeichen) = CR)
        THEN BEGIN
          dummy := CHR (ORD (CR));
          IF (pindex <= pende) THEN dummy := puffer [WORD (pindex)];
          (* END IF *);
          IF (dummy = CHR (ORD (LF))) AND (pindex < pende) THEN
            dummy := puffer [WORD (pindex) + 1];
          (* END IF *);
          IF dummy <> CHR (ORD (CR)) THEN BEGIN
            CASE AusgabeFormat OF
              FIRSTWORD: BEGIN   PutZeichen (CHR (ORD (FWVarSpace)));
                                 ZeigZeichen (CHR (ORD (FWVarSpace)));
                         END;
              WS30DOC..WS34MSDOS: BEGIN
                                    PutZeichen (CHR (ORD (WSSpace)));
                                    ZeigZeichen (CHR (ORD (WSSpace)));
                                  END;
              SMTEXT:      ;
              ELSE PutZeichen (' ');
            END (* CASE *);
            IncUCSD;
          END (* IF naechste Zeile nicht leer *);
      END (* IF BlankEinfuegen *);

      (* WordStar CR durch weiches Zeilenende ersetzen: *)
      CASE AusgabeFormat OF
        WS30GER, WS30SPA, WS30DOC, WS34MSDOS: BEGIN
          IF EingabeFormat IN [FIRSTWORD, SIMPEL, G2E] THEN BEGIN
            IF (ZeichenSatz (Zeichen) = CR) THEN BEGIN
                   IF Leergemerkt THEN
                     Zeichen := CHR (ORD (WSRETURN));
                   (* END IF SP *);
            END (* IF CR *);
          END
          ELSE BEGIN
            IF (ZeichenSatz (Zeichen) = CR) AND
             (WordStarMarkiert OR NOT LetzteZeileLeer) AND
             (EingabeFormat <> UCSD)
            THEN Zeichen := CHR (ORD (WSRETURN));
          END (* IF weiches RETURN *);
        END (* WS30GER ... *);
        UCSD: BEGIN
                IF ZeichenSatz (Zeichen) > DEL
                  THEN Zeichen := CHR (ORD (Zeichen) MOD 128);
                (* END IF 8. Bit *);
              END;
        MSWORD, ANSIEndlos: BEGIN
              IF (ZeichenSatz (Zeichen) = CR) AND
                 ((WordStarMarkiert OR
                  ((EingabeFormat IN [USASCII128, GERASCII128,
                                          ASCII256, SMTEXT]) AND
                   NOT LetzteZeileLeer)) OR
                  ((EingabeFormat IN [FIRSTWORD, SIMPEL, G2E]) AND Leergemerkt))
                THEN BEGIN
                  LiesZeichen (Zeichen); (* naechstes Zeichen n. Z. *)
                  {IF EingabeHatLinefeed THEN LiesZeichen (Zeichen);}
                  SchreibSonderZeichen (Zeichen);
                END
                     (* Word verwendet keine CR in Absaetzen *)
              (* END IF CR *);
                END (* MSWORD *);
        ELSE;
      END (* CASE weiches CR *);

      (* Tabulation: *)
      IF (ZeichenSatz (Zeichen) = HT) AND TabFiltern THEN
        FOR s := Spalte + 1 TO
          ((Spalte DIV Tabspace + 1) * Tabspace) DO BEGIN
                   PutZeichen (' ');
                   ZeigZeichen (' '); IncUCSD;
        END (* FOR *)
      ELSE BEGIN
        PutZeichen (Zeichen);
        (* Falls Zeilenende: *)
           IF ((ZeichenSatz (Zeichen) = WSRETURN) AND
               (AusgabeFormat IN [WS30DOC, WS30GER, WS30SPA,
                                          WS34MSDOS]))
             THEN ZeigZeichen (CHR (ORD (CR)))
             ELSE ZeigZeichen (Zeichen);
           (* END IF *);
           IncUCSD;
           (* Ev. Linefeed schreiben *)
           IF ((ZeichenSatz (Zeichen) = CR) OR
               (ZeichenSatz (Zeichen) = WSRETURN)) AND
               AusgabeHatLinefeed
             THEN PutZeichen (CHR (ORD (LF)));
           (* END IF Linefeed *);

           (* Ev. zweites CR zur Absatzmarkierung: *)
           IF ((ZeichenSatz (Zeichen) = CR) AND NOT WordStarMarkiert AND
                NOT AbsatzMarkiert AND
                  (AusgabeFormat IN
                    [UCSD, ASCII256, SMTEXT, SIMPEL,
                             GERASCII128, USASCII128])
                  (* Wenn Eingabe als WS-Text interpretiert: *)
                  AND ((EingabeFormat IN
                    [WS30DOC, WS30GER, WS30SPA, WS34MSDOS,
                             MSWORD, ANSIEndlos]) OR
                     ((EingabeFormat IN [FIRSTWORD, SIMPEL, G2E]) AND NOT Leergemerkt)))
             THEN BEGIN
                  PutZeichen (CHR (ORD (CR)));
                  ZeilenEnde := TRUE; ZeigZeichen (CHR (ORD (CR)));
                  AbsatzMarkiert := TRUE;
                  IncUCSD;
                  IF AusgabeHatLinefeed THEN PutZeichen (CHR (ORD (LF)));
                  (* END IF Linefeed *);
             END
             ELSE BEGIN
                  IF (ZeichenSatz (Zeichen) <> CR)
                    THEN AbsatzMarkiert := FALSE;
                  (* END IF *);
           END (* IF CR *);
      END (* IF Zeichen *);

      CASE ZeichenSatz (Zeichen) OF
        SP, WSSpace, FWStretch, FWIndent, FWVarSpace, Minus, Schraeg:
          Leergemerkt := TRUE;
          ELSE Leergemerkt := FALSE;
      END (* CASE *);

      (* Zeilenumbruch in Word-Absaetzen: *)
      IF (EingabeFormat IN [MSWORD, ANSIEndlos]) AND (Spalte >= Umbruch)
         AND (AusgabeFormat IN [UCSD, SIMPEL, G2E]) THEN BEGIN
        CASE ZeichenSatz (Zeichen) OF
          SP, WSSpace, FWStretch, FWIndent, FWVarSpace: BEGIN
              CASE AusgabeFormat OF
                WS30GER, WS30SPA, WS30DOC, WS34MSDOS:
                    PutZeichen (CHR (ORD (WSRETURN)));
                UCSD: BEGIN PutZeichen (CHR (ORD (CR))); IncUCSD; END;
                ELSE PutZeichen (CHR (ORD (CR)));
              END (* CASE *);
              IF AusgabeHatLinefeed THEN PutZeichen (CHR (ORD (LF)));
              (* END IF LF *);
              ZeilenEnde := TRUE;
              LetzteZeileLeer := FALSE; DieseZeileLeer := TRUE;
              ZeigZeichen (CHR (ORD (CR)));
            END (* SP, WSSpace ... *)
          ELSE; (* Kein Leerzeichen *)
        END (* CASE Leerzeichen *);
      END (* IF MSWORD-Umbruch *);

      IF (AusgabeFormat = WS34MSDOS) AND (ZeichenSatz (Zeichen) >= Cedill) THEN
        PutZeichen (CHR (ORD (WSEndMark)));
      (* END IF WS 3.4 *);

      IF schreibBlank THEN BEGIN
         PutZeichen (' '); schreibBlank := FALSE;
      END (* IF *);
    END (* IF Ende *);
  END (* SchreibZeichen *);

  PROCEDURE DoUCSD;
  VAR   ch, ch1:        CHAR;
        ind:            WORD;
  BEGIN
    LiesZeichen (ch);

    IF (ZeichenSatz (ch) >= SP) THEN
    (* Es handelt sich um ein druckbares Zeichen *)
        SchreibZeichen (ch)
      ELSE BEGIN
        CASE ZeichenSatz (ch) OF
          UCSDBlank: BEGIN
                       LiesZeichen (ch);
                       FOR ind := 1 TO ORD (ch) - 32 DO BEGIN
                         SchreibZeichen (' ');
                       END (* FOR *);
                     END;
          CR:      BEGIN
                     LiesZeichen (ch);
                     IF (ZeichenSatz (ch) >= SP) THEN BEGIN
                       SchreibZeichen (' ');
                            IF AusgabeFormat IN [WS30DOC, WS30GER,
                                                 WS30SPA, WS34MSDOS]
                              THEN SchreibZeichen (CHR (ORD (WSRETURN)))
                              ELSE SchreibZeichen (CHR (ORD (CR)));
                              (* Absatz *)
                            (* END Absatz *);
                            SchreibZeichen (ch);
                     END
                     ELSE
                       IF ZeichenSatz (ch) = UCSDBlank THEN BEGIN
                            LiesZeichen (ch);
                            LiesZeichen (ch1);
                            IF ZeichenSatz (ch1) = CR THEN BEGIN
                              SchreibZeichen (' ');
                              SchreibZeichen (CHR (ORD (CR)));
                            END
                            ELSE BEGIN SchreibZeichen (' ');
                              IF AusgabeFormat IN [WS30DOC, WS30GER,
                                                   WS30SPA, WS34MSDOS]
                                THEN SchreibZeichen (CHR (ORD (WSRETURN)))
                                ELSE SchreibZeichen (CHR (ORD (CR)));
                                (* Absatz *)
                              (* END Absatz *);
                            END (* IF ch1 = CR *);
                            FOR ind := 1 TO ORD (ch) - 32 DO BEGIN
                              SchreibZeichen (' ');
                            END (* FOR *);
                            SchreibZeichen (ch1);
                       END
                     ELSE
                       IF ZeichenSatz (ch) = CR THEN BEGIN
                            SchreibZeichen (' ');
                            SchreibZeichen (ch);
                            SchreibZeichen (ch);
                     END (* ELSIF UCSDBlank *);
          END (* CR *);
          ELSE;
        END (* CASE *);
    END (* ELSE nicht druckbar *);
  END (* DoUCSD *);

  PROCEDURE SchreibZeile (Z: STRING);
  VAR     i:        WORD;
  BEGIN
    FOR i := 1 TO LENGTH (Z) DO BEGIN
      SchreibZeichen (Z [i]);
    END (* FOR *);
  END (* SchreibZeile *);

  PROCEDURE FragZeile (VAR Z: STRING);
  BEGIN
    Write ('> ');
    ReadLn (Z);
  END (* FragZeile *);
{
  PROCEDURE DoMailBox;
  VAR     Zeile:    STRING [80];
          Anz:      BOOLEAN;
  BEGIN
    Anz := Anzeigen; Anzeigen := TRUE;
    SchreibZeile ('*** BRS DOCUMENT BOUNDARY ***');
    ZeilenEnde := TRUE; SchreibZeichen (CHR (ORD (CR)));
    SchreibZeile ('.lng. ');
    ZeilenEnde := TRUE; SchreibZeichen (CHR (ORD (CR)));
    SchreibZeile ('.datum. ');
    ZeilenEnde := TRUE; SchreibZeichen (CHR (ORD (CR)));
    SchreibZeile ('.rubrik. ');
    ZeilenEnde := TRUE; SchreibZeichen (CHR (ORD (CR)));
    SchreibZeile ('.srub. ');
    ZeilenEnde := TRUE; SchreibZeichen (CHR (ORD (CR)));
    SchreibZeile ('.que. ');
    FragZeile (Zeile);
    SchreibZeile (Zeile);
    ZeilenEnde := TRUE; SchreibZeichen (CHR (ORD (CR)));
    SchreibZeile ('.bezug. ');
    ZeilenEnde := TRUE; SchreibZeichen (CHR (ORD (CR)));
    SchreibZeile ('.titel. ');
    FragZeile (Zeile);
    SchreibZeile (Zeile);
    ZeilenEnde := TRUE; SchreibZeichen (CHR (ORD (CR)));
    SchreibZeile ('.text.');
    ZeilenEnde := TRUE; SchreibZeichen (CHR (ORD (CR)));
    Anzeigen := Anz;
  END (* DoMailBox *);
}
VAR     index:  WORD;
        ok:     INTEGER;
        bok:    BOOLEAN;
        byte:   CHAR;
        ch:     CHAR;
        IORes:  INTEGER;

BEGIN (* Filtern *)

  Write ('Initialisierung...');

  Ende := FALSE; ZeilenEnde := FALSE;
  DieseZeileLeer := TRUE; LetzteZeileLeer := FALSE;
  AbsatzMarkiert := FALSE; WordStarMarkiert := FALSE;
  UCSDEin := 0; UCSDAus := 0;
  Leergemerkt := FALSE; schreibBlank := FALSE; TrennHilfe := FALSE;
  EinAttribut := []; AusAttribut := [];
  AttributGeschaltet := FALSE;

  FOR index := 0 TO 1023 DO BEGIN
    UCSDInf.dumm [index] := CHR (0);
  END (* FOR *);
  FOR index := 0 TO 7 DO BEGIN
    WordInf.dumm1 [index] := CHR (0);
  END (* FOR *);
  FOR index := 0 TO 109 DO BEGIN
    WordInf.dumm2 [index] := CHR (0);
  END (* FOR *);
  WordInf.Anzahl0 := 0; WordInf.Anzahl1 := 0;
  WordInf.Magik1 := 0; WordInf.Magik2 := 0; WordInf.Magik3 := 0;

  WriteLn;

  (*LoescheBild; CursorAus;*)
  ClrScr;
  (*Terminal.WriteString ("Name der Eingabe-Datei: ");*)
  (* TextIO.ReadString (EinName); *)
  (* ReadString (EinName);
  WriteLn; *)
  (* Assign (EinName, ''); Assign (AusName, ''); *)
  (*
  GetDirectory (EinPfad, EinName, 'Name der Quelldatei', ok, FALSE);
  IF ok # 1 THEN RETURN END;
  *)

  EinName := ''; AusName := '';
  Write ('Name der Quell-Datei: '); ReadLn (EinName);

  EinPf := EinPfad; (*DeleteTail (EinPf);*)
  EinPf := EinPf + Einname;

  IF NOT Analysieren THEN BEGIN
    (*Terminal.WriteString ("Name der Ausgabe-Datei: ");*)
    (* TextIO.ReadString (AusName); *)
    (* ReadString (AusName);
    WriteLn;
    *)
    AusName := EinName;
    (*
    GetDirectory (AusPfad, AusName, 'Name der Zieldatei', ok, FALSE);
    IF ok # 1 THEN RETURN END;
    *)
    Write ('Name der Zieldatei: ');
    ReadLn (AusName);
    (*CursorEin;*)
    AusPf := AusPfad; (*DeleteTail (AusPf);*)
    (*Append (AusName, AusPf);*)
    AusPf := AusPf + AusName;

    IF EinPf = AusPf THEN BEGIN
      Write ('Die Dateinamen muessen verschieden sein! <RETURN>');
      ReadLn;
      EXIT;
    END;
  END (* IF NOT Analysieren *);
  WriteLn;

  (* Eroeffnen der Dateien:*)

(*$I-*)
{
WriteLn; Write ('Eingabedatei inh erffnen: ', EinPf); ReadLn;
}
  Assign (inh, EinPf); Reset (inh, 1);

  (*IF inh >= 0 THEN*)
  IORes := IOResult;
  IF IORes = 0 THEN BEGIN

    LiesPuffer (inh);
   (* Borland-Modula: *)
   (* NoTrailer (Eingabe); *)

    IF NOT Analysieren THEN BEGIN
      (* OpenStream (Ausgabe, AusPf, READWRITE, ok);
      IF ok # 0 THEN *)
      (*Create (AusPf, 0, outh);*)
      Assign (outh, AusPf); Rewrite (outh, 1);

      (*IF outh = 0 THEN*)
      IORes := IOResult;
      IF IORes <> 0 THEN BEGIN
        WriteLn; WriteLn;
        Write ('Kann Ausgabedatei nicht eroeffnen (', IORes, ') <RETURN>');
        ReadLn;
        (* CloseStream (Ausgabe, ok); *)
        EXIT;
      END (* IF Ausgabe nicht ok *);
      (* Borland-Modula: *)
      (* NoTrailer (Ausgabe); *)
    END (* IF ~Analysieren *);

    (* Formate mit Vorlauf-Record: *)
 {}
    CASE EingabeFormat OF
      MSWORD: BEGIN
                Write ('Word-Header lesen...');
                ReadRec (WordInf, SizeOf (WordInf));

                WITH WordInf DO BEGIN

                  ByteSex (Anzahl0); ByteSex (Anzahl1);
                  ByteSex (Magik1); ByteSex (Magik2); ByteSex (Magik3);
                  WriteLn;
                  Write ('Magik 1: ');
                  WriteLn (Magik1:5);
                  Write ('Magik 2: ');
                  WriteLn (Magik2:5);
                  Write ('Magik 3: ');
                  WriteLn (Magik3:5);

                  IF (Magik1 = 48689) AND (Magik2 = 0) AND (Magik3 = 43776) THEN BEGIN
                     (* Wir muessen von der Laengenangabe 128 abziehen: *)
                    IF (Anzahl0 < 131) THEN BEGIN
                      DEC (Anzahl1); INC (Anzahl0, 65405);
                    END
                    ELSE BEGIN DEC (Anzahl0, 128);
                    END (* IF Anzahl0 *);
                    WriteLn; Write ('Anzahl 0: ');
                    Write (Anzahl0:5);
                    Write (', Anzahl 1: ');
                    Write (Anzahl1:5);
                  END
                  ELSE BEGIN (* CloseStream (Eingabe, ok);
                        OpenStream (Eingabe, EinName, READ, ok); *)
                        (*Open (EinPf, ORD (read), inh);*)
                        Assign (inh, EinPf);
                        Reset (inh, 1);
                        LiesPuffer (inh);
                        Anzahl0 := 65535; Anzahl1 := 65535;
                  END (* IF Magik *);
                END (* WITH *);
                WriteLn; WriteLn;
              END (* CASELabel *);
      UCSD: BEGIN
              Write ('UCSD-Header ueberlesen...');
              (* ReadRec (Eingabe, UCSDInf); *)
              FOR index := 0 TO 1023 DO BEGIN
                GetZeichen (dummy);
              END (* FOR *);
              WriteLn;
            END;
      ELSE;
    END (* CASE EingabeFormat *);

    IF NOT Analysieren THEN BEGIN
      CASE AusgabeFormat OF
        UCSD: BEGIN
                Write ('UCSD-Header schreiben...');
                (* WriteRec (Ausgabe, UCSDInf); *)
                FOR index := 0 TO 1023 DO BEGIN
                  PutZeichen (CHR (0));
                END (* FOR *);
                WriteLn;
              END;
        ELSE;
      END (* CASE *);
    END (* IF NOT Analysieren *);

    Spalte := 0; ZeichenZahl0 := 0; ZeichenZahl1 := 0;
    ZeichenZahl := 0; ZeilenZahl := 0;
    {IF NOT Analysieren AND MailBox THEN DoMailBox;}
    REPEAT
      IF EingabeFormat = UCSD
        THEN DoUCSD
      ELSE BEGIN LiesZeichen (ZwischenCode);
           IF Analysieren THEN BEGIN
             ZeigZeichen (ZwischenCode);
           END ELSE BEGIN
             SchreibZeichen (ZwischenCode);
           END (* IF Analysieren *);
      END (* IF EingabeFormat *);
      IF keypressed THEN BEGIN
        ch := ReadKey;
        WriteLn; WriteLn;
        Write ('Konvertierung abbrechen und Zieldatei schlieen? (J/N) ');
        ch := UpCase (ReadKey);
        IF ch = 'J' THEN Ende := TRUE
        ELSE WriteLn;
      END (* IF *);
    UNTIL Ende;
 {}
    IF NOT Analysieren THEN BEGIN
      CASE AusgabeFormat OF
        UCSD: BEGIN
                FOR index := UCSDAus + 1 TO 1024 DO BEGIN
                  PutZeichen (CHR (0));
                END (* FOR *);
              END;
        ELSE IF AusgabeHatControlZ THEN BEGIN
               PutZeichen (CHR (ORD (SUB)));
             END (* IF *);
      END (* CASE *);
{
      IF MailBox THEN BEGIN
        SchreibZeile ('.adr. ');
        ZeilenEnde := TRUE;
        SchreibZeichen (CHR (ORD (CR)));
      END (* IF *);
}
      IF outindex > 0 THEN SchreibPuffer (outh);
      (* CloseStream (Ausgabe, ok); *)
      Close (outh);
    END (* IF ~Analysieren *);

    (* CloseStream (Eingabe, ok); *)
    Close (inh);
  END
  ELSE BEGIN
    Write ('Eingabedatei nicht gefunden (', IORes, ') <RETURN>');
    ReadLn;
    EXIT;
  END (* IF IOResult = *);

  WriteLn; WriteLn;
  WriteLn ('Zaehler1: ', ZeichenZahl1:5, ', Zaehler0: ', ZeichenZahl0:5);
  WriteLn ('Zeilen: ', ZeilenZahl:5);

  Write ('<RETURN>');
  ReadLn;
END (* Filtern *);

(***************************************************************)

VAR     befehl:         CHAR;

BEGIN (* SuperFilter *)
  {MausAus; CursorEin;}
  EingabeFormat := (* ASCII256 *) SIMPEL;
  {EingabeFormat := TOOLBOOK;}
  AusgabeFormat := (* ASCII256 *) ASCII256;
  {}AusgabeFormat := ANSIEndlos;
  TabFiltern := TRUE; BlankEinfuegen := FALSE;
  Indent := FALSE;
  Anzeigen := FALSE;
  DekodiereSteuer := TRUE;
  {}Anzeigen := TRUE;
  Analysieren := FALSE; {MailBox := FALSE;}
  SteuerzeichenFiltern := FALSE;
  {}SteuerzeichenFiltern := TRUE;
  EingabeHatControlZ := (* TRUE *) FALSE;
  AusgabeHatControlZ := FALSE;
  EingabeHatLinefeed := TRUE;
  {EingabeHatLinefeed := FALSE;}
  AusgabeHatLinefeed := TRUE;
  {AusgabeHatLinefeed := FALSE;}
  WSAttributeSetzen := FALSE;
  Tabspace := 8; Umbruch := 65;
  Limit0 := High (WORD); Limit1 := High (Word);
  {Limit0 := 60000; Limit1 := 0;}
  IBM := (* FALSE *) TRUE;
  EinPfad := ''; AusPfad := '';
  EinName := ''; AusName := '';
  REPEAT
    Menue (EingabeFormat, AusgabeFormat,
           TabFiltern, SteuerzeichenFiltern,
           EingabeHatControlZ, AusgabeHatControlZ,
           EingabeHatLinefeed, AusgabeHatLinefeed,
           Tabspace, Umbruch, Anzeigen, IBM, Prefixed,
           BlankEinfuegen, {MailBox,} Indent, WSAttributeSetzen,
           Limit0, Limit1);
    befehl := UpCase (ReadKey);
    WriteLn; WriteLn;
    CASE befehl OF
      'A':    BEGIN
                WriteLn ('Ausgabe-Format:');
                WaehleFormat (AusgabeFormat);
                CASE AusgabeFormat OF
                  USASCII128, GERASCII128, ASCII256, SMTEXT, WS30DOC,
                  WS30GER, WS30SPA:
                  BEGIN
                    AusgabeHatLinefeed := TRUE;
                    AusgabeHatControlZ := TRUE;
                    IBM := TRUE;
                  END;
                  WS34MSDOS:
                  BEGIN
                    AusgabeHatLinefeed := TRUE;
                    AusgabeHatControlZ := FALSE;
                    IBM := TRUE;
                  END;
                  SIMPEL, G2E:
                  BEGIN
                    AusgabeHatLinefeed := TRUE;
                    AusgabeHatControlZ := FALSE;
                    IBM := FALSE;
                  END;
                  FIRSTWORD:
                  BEGIN
                    AusgabeHatLinefeed := TRUE;
                    AusgabeHatControlZ := FALSE;
                    IBM := FALSE;
                  END;
                  MSWORD:
                  BEGIN
                    AusgabeHatLinefeed := TRUE;
                    AusgabeHatControlZ := FALSE;
                    IBM := TRUE;
                  END;
                  ANSI, ANSIEndlos:
                  BEGIN
                    AusgabeHatLinefeed := TRUE;
                    AusgabeHatControlZ := FALSE;
                  END;
                  UCSD:
                  BEGIN
                    AusgabeHatLinefeed := FALSE;
                    AusgabeHatControlZ := FALSE;
                    TabFiltern := TRUE;
                  END;
                  ELSE;
                END (* CASE *);
              END;
      'B':    BEGIN
                Write ('Tabbreite: ');
                ReadLn (Tabspace);
              END;
      'C':    BEGIN
                BlankEinfuegen := NOT BlankEinfuegen;
              END;
      'E':    BEGIN
                WriteLn ('Eingabe-Format:');
                WaehleFormat (EingabeFormat);
                CASE EingabeFormat OF
                  USASCII128, GERASCII128, WS30DOC, WS30GER,
                  WS30SPA, ASCII256:
                  BEGIN
                    EingabeHatLinefeed := TRUE;
                    BlankEinfuegen := FALSE;
                  END;
                  TOOLBOOK:
                  BEGIN
                    EingabeHatLinefeed := FALSE;
                    SteuerzeichenFiltern := TRUE; (* ??? *)
                  END;
                  FIRSTWORD, SIMPEL, G2E:
                  BEGIN
                    EingabeHatLinefeed := TRUE;
                    EingabeHatControlZ := FALSE;
                    BlankEinfuegen := FALSE;
                  END;
                  WS34MSDOS:
                  BEGIN
                    EingabeHatLinefeed := TRUE;
                    EingabeHatControlZ := FALSE;
                    BlankEinfuegen := FALSE;
                  END;
                  MSWORD:
                  BEGIN
                    EingabeHatLinefeed := TRUE;
                    EingabeHatControlZ := FALSE;
                    BlankEinfuegen := FALSE;
                  END;
                  ANSI, ANSIEndlos:
                  BEGIN
                    EingabeHatLinefeed := FALSE;
                    EingabeHatControlZ := FALSE;
                  END;
                  UCSD:
                  BEGIN
                    EingabeHatLinefeed := FALSE;
                    EingabeHatControlZ := FALSE;
                    BlankEinfuegen := FALSE;
                  END;
                  SMTEXT:
                  BEGIN
                    EingabeHatLinefeed := TRUE;
                    BlankEinfuegen := TRUE;
                  END;
                  ELSE;
                END (* CASE *);
               END;
      'F':    BEGIN
                Analysieren := FALSE;
                Filtern;
              END;
      'H':      Indent := NOT Indent;
      'I':      IBM := NOT IBM;
      'K':      EingabeHatLinefeed := NOT EingabeHatLinefeed;
      'L':      AusgabeHatLinefeed := NOT AusgabeHatLinefeed;
      {'M':      MailBox := NOT MailBox;}
      'M':      BEGIN
                  ClrScr; Write ('Maximum High: ', Limit1, ', neu: ');
                  ReadLn (Limit1);
                  WriteLn; Write ('Maximum Low: ', Limit0, ', neu: ');
                  ReadLn (Limit0);
                END;
      'N':      BEGIN Limit0 := High (WORD); Limit1 := High (WORD); END;
      'P':      Prefixed := NOT Prefixed;
      'S':      Anzeigen := NOT Anzeigen;
      'T':      TabFiltern := NOT TabFiltern;
      'U':    BEGIN
                Write ('Umbruch-Breite: ');
                ReadLn (Umbruch);
              END;
      'W':      WSAttributeSetzen := NOT WSAttributeSetzen;
      'X':      SteuerzeichenFiltern := NOT SteuerzeichenFiltern;
      'Y':      EingabeHatControlZ := NOT EingabeHatControlZ;
      'Z':      AusgabeHatControlZ := NOT AusgabeHatControlZ;
      '#':    BEGIN
                AnalyseFormat := EingabeFormat;
                AnalyseAnzeigen := Anzeigen;
                AnalyseLinefeed := EingabeHatLinefeed;
                AnalyseControlZ := EingabeHatControlZ;
                Analysieren := TRUE; Anzeigen := TRUE;
                EingabeHatLinefeed := FALSE; EingabeHatControlZ := FALSE;
                EingabeFormat := ASCII256;
                Filtern;
                EingabeFormat := AnalyseFormat;
                Anzeigen := AnalyseAnzeigen;
                EingabeHatLinefeed := AnalyseLinefeed;
                EingabeHatControlZ := AnalyseControlZ;
              END;
      ELSE;
    END (* CASE *);
  UNTIL (befehl = 'Q') OR (befehl = escape);
  (*
  ClearAES;
  CursorAus; MausEin;
  *)
END (* SuperFilter *).